#!/usr/bin/env python
#@+leo
#@+node:0::@file tkpsst.py
#@+body
#@@first
#@@language python
#@+others
#@+node:1::imports
#@+body
# fudge

try:
    x = True
except:
    True = 1
    False = 0

# system
from pdb import set_trace as trace
import sys, os, glob, re, types, os.path, time, pickle, Queue, socket
import webbrowser, thread, math, md5, base64
import random
import sha
import httplib
import commands
from binascii import hexlify as hexdump
import Tkinter
from Tkinter import *
import tkMessageBox
from tkFileDialog import askopenfilename, asksaveasfilename

# C modules
import SSLCrypto

# Global Python Modules
import Pmw

# Local Python modules
from tVector import *
import audio
import Tree

# self-import
import tkpsst as psst

#@-body
#@-node:1::imports
#@+node:2::exceptions
#@+body
class psstSetupFinishException(Exception):
    pass

class ConnectionClosedError(Exception):
    """Trying to send data on a closed connection"""
    pass


#@-body
#@-node:2::exceptions
#@+node:3::globals
#@+body
psstVersion = '0.3'

gConnections = {}

connOpts = ['Accept Automatically', 'Ask My Permission', 'Always Block']

defaultPort = '44515'

pingTimeout = 90

speechQuality = 5

reUrls = re.compile("((ftp://)|(http://)|(www\\.))([a-zA-Z0-9\\-_]+)(\\.[a-zA-Z0-9\\-_]+)+")

gWinMain = None # set to main window's ref

psst.running = True

#@-body
#@-node:3::globals
#@+node:4::GUI
#@+node:1::Windows
#@+node:1::class winMain
#@+body

class winMain:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, master):
    
        master.config(borderwidth=0)
    
        # Grab configs
        #print "main(): file =", f
        if len(sys.argv) > 1:
            f = sys.argv[1]
        else:
            f = None
    
        psst.theme = Theme()
        self.applyTheme(master, psst.theme)
    
        psst.config = ConfigFactory('', f)
    
        # Load the required theme
        try:
            themename = psst.config.theme
        except:
            themename = "default"
    
        #themename = "template"
        psst.theme = Theme(themename)
        self.applyTheme(master, psst.theme)
    
        # construct this and other windows
        self.buildWindows(master)
    
        global queueMain
        queueMain = myQueue(size=1024, widget=self.win, callback=self.on_idle)
    
        #trace()
    
        if 'voxtest' in sys.argv:
            print "audio disabled"
            psst.voxtest = True
            def playsound(filename):
                print "playsound(): disabled due to voxtest mode"
            psst.audioObj = None
            psst.playsound = playsound
        else:
            psst.voxtest = False
            try:
                psst.audioObj = audio.audioFactory(speechQuality)
                psst.playsound = psst.audioObj.playsound
            except:
                print "Error initialising sound I/O - continuing without sound"
                psst.audioObj = None
                psst.playsound = psst.playsoundNull
    
        # Create setup wizard
        self.setupWiz = wizSetup(master)
    
        self.frmMain.after(100, self.on_startup)
    
    
    #@-body
    #@-node:1::__init__
    #@+node:2::applyTheme
    #@+body
    def applyTheme(self, master, theme):
    
        return
    
        # Condition the widget palette.
        #master.tk_setPalette(
        #    background=theme.tkBgColor,
        #    foreground=theme.tkFgColor,
        #    selectColor=theme.tkSelColor,
        #    activeForeground=theme.tkActiveFgColor,
        #    highlightBackground=theme.tkHighlightBgColor,
        #    selectBackground=theme.tkSelBgColor,
        #    highlightColor=theme.tkHighlightColor,
        #    selectForeground=theme.tkSelFgColor,
        #    disabledForeground=theme.tkDisabledFgColor,
        #    insertBackground=theme.tkInsBgColor,
        #    troughColor=theme.tkTroughColor
        #    )
    
        #t = Toplevel(master)
        #t.withdraw()
        #t.tk_setPalette(
        #    background=theme.tkBgColor,
        #    foreground=theme.tkFgColor,
        #    selectColor=theme.tkSelColor,
        #    activeForeground=theme.tkActiveFgColor,
        #    highlightBackground=theme.tkHighlightBgColor,
        #    selectBackground=theme.tkSelBgColor,
        #    highlightColor=theme.tkHighlightColor,
        #    selectForeground=theme.tkSelFgColor,
        #    disabledForeground=theme.tkDisabledFgColor,
        #    #insertBackground=theme.tkInsBgColor,
        #    troughColor=theme.tkTroughColor
        #    )
    
        #return
    
        #Canvas().tk_setPalette(
        #    background=theme.frmBgColor,
            #foreground=theme.tkFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
        #    )
    
    
        #Checkbutton().tk_setPalette(
        #    background=theme.chkBgColor,
        #    foreground=theme.chkFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
        #    )
    
        #Entry().tk_setPalette(
        #    background=theme.entryBgColor,
        #    foreground=theme.entryFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
        #    )
    
        return
    
        Frame().tk_setPalette(
            #background=theme.frmBgColor,
            background='yellow',
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
    
        Label().tk_setPalette(
            background=theme.labBgColor,
            foreground=theme.labFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
    
    
        Listbox().tk_setPalette(
            background=theme.listBgColor,
            foreground=theme.listFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            selectBackground=theme.listSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            selectForeground=theme.listSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
           
        Menu().tk_setPalette(
            background=theme.menuBgColor,
            foreground=theme.menuFgColor,
            #selectColor=theme.tkSelColor,
            activeForeground=theme.menuActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            selectBackground=theme.menuActiveBgColor,
            #highlightColor=theme.tkHighlightColor,
            selectForeground=theme.menuActiveFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
        #Menubutton().tk_setPalette(
        #    background=theme.menuBgColor,
        #    foreground=theme.menuFgColor,
            #selectColor=theme.tkSelColor,
        #    activeForeground=theme.menuActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
        #    selectBackground=theme.menuActiveBgColor,
            #highlightColor=theme.tkHighlightColor,
        #    selectForeground=theme.menuActiveFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
        #    )
    
        #Scale().tk_setPalette(
        #    background=theme.tkBgColor,
        #    foreground=theme.tkFgColor,
        #    selectColor=theme.tkSelColor,
        #    activeForeground=theme.tkActiveFgColor,
        #    highlightBackground=theme.tkHighlightBgColor,
        #    selectBackground=theme.tkSelBgColor,
        #    highlightColor=theme.tkHighlightColor,
        #    selectForeground=theme.tkSelFgColor,
        #    disabledForeground=theme.tkDisabledFgColor,
        #    #insertBackground=theme.tkInsBgColor,
        #    troughColor=theme.tkTroughColor
        #    )
    
        #Scrollbar().tk_setPalette(
        #    background=theme.scrlBgColor,
        #    foreground=theme.scrlFgColor,
        #    selectColor=theme.scrlBgColor,
        #    activeForeground=theme.scrlFgColor,
        #    highlightBackground=theme.scrlBgColor,
        #    selectBackground=theme.scrlBgColor,
        #    highlightColor=theme.scrlFgColor,
        #    selectForeground=theme.scrlFgColor,
        #    disabledForeground=theme.scrlFgColor,
        #    insertBackground=theme.scrlBgColor,
        #    troughColor=theme.scrlBgColor
        #    )
        Text().tk_setPalette(
            background=theme.textBgColor,
            foreground=theme.textFgColor,
            #selectColor=theme.tkSelColor,
            #activeForeground=theme.tkActiveFgColor,
            #highlightBackground=theme.tkHighlightBgColor,
            #selectBackground=theme.tkSelBgColor,
            #highlightColor=theme.tkHighlightColor,
            #selectForeground=theme.tkSelFgColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
    
        return
    
        Button().tk_setPalette(
            background=theme.butBgColor,
            foreground=theme.butFgColor,
            selectColor=theme.butSelColor,
            activeForeground=theme.butActiveFgColor,
            activeBackground=theme.butActiveBgColor,
            highlightBackground=theme.butHighlightColor,
            selectBackground=theme.butActiveBgColor,
            #highlightColor=theme.butActiveFgColor,
            #selectForeground=theme.butSelColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
    
    #@-body
    #@-node:2::applyTheme
    #@+node:3::on_startup
    #@+body
    def on_startup(self):
        if not psst.config.valid:
            print "launching config wizard"
            if not self.setupWiz.show(): # user cancelled out
                sys.exit(1)
    
        # update peers list
        self.refreshPeers()
        #self.components.listPeers.SetFocus()
    
        # fire up connection listener thread
        thread.start_new_thread(threadListener, (psst.config, putMainQueue))
    
        # fire up dummy thread
        #thread.start_new_thread(threadDummy, ())
    
        #psst.playsound("shorttheme.wav")
        psst.playsound("sounds/sample.wav")
        logMsg("PSST started successfully")
    
        self.xOld, self.yOld = self.frmMain.winfo_pointerxy()
        self.frmMain.after(1000, self.on_ticker)
        #trace()
    
    #@-body
    #@-node:3::on_startup
    #@+node:4::buildWindows
    #@+body
    def buildWindows(self, master):
        """
        Construct the windows via Tk and PMW
        """
        global gWinMain
        global app
        gWinMain = app = self
    
        self.win = master
    
        theme = psst.theme
        master['bg'] = theme.winBgColor
    
        # construct dialogs
        #self.winSession = winSession(self.win)
        self.dlgHelpAbout = dlgHelpAbout(self.win)
        self.dlgPeer = dlgPeer(self.win)
        self.dlgSettings = dlgSettings(self.win)
        self.dlgPassphrase = dlgPassphrase(self.win)
    
        master.protocol("WM_DELETE_WINDOW", self.on_close)
        master.title("PSST - High-strength encrypted chat")
    
        self.frmMain = myFrame(master,
                             #title="PSST - High-strength encrypted chat",
                             #width=10, height=10,
                             )
        self.frmMain.pack(side=LEFT,
                          fill=BOTH,
                          expand=1,
                          )
    
        # Construct the menu
        self.buildMenu(master)
    
        self.toppanes = myPanedWidget(self.frmMain,
                                      orient='vertical',
                                      hull_borderwidth=1,
                                      separatorrelief='raised',
                                      )
        self.toppanes.pack(fill=BOTH, expand=1)
        self.frmButtons = self.toppanes.add('buttons', size=32)
    
        self.frmTop = self.toppanes.add('top')
        
        self.frmBottom = self.toppanes.add('bottom', size=24, min=0.1, max=0.5)
    
        self.butConnect = myButton(self.frmButtons,
                                   text="Connect",
                                   command = self.on_butConnect,
                                   #width=16,
                                   )
        self.butConnect.pack(side=LEFT)
    
        self.butGetIP = myButton(self.frmButtons,
                                 text="My IP?",
                                 command=self.on_butGetMyIP,
                                 #width=16,
                               )
        self.butGetIP.pack(side=LEFT)
    
        self.butMsgGetNew = myButton(self.frmButtons,
                                     text="Get New",
                                     command=self.on_butMsgGetNew,
                                     )
        self.butMsgGetNew.pack(side=LEFT)
        self.butMsgCompose = myButton(self.frmButtons,
                                      text="Compose",
                                      command=self.on_butMsgCompose,
                                      )
        self.butMsgCompose.pack(side=LEFT)
        self.butMsgReply = myButton(self.frmButtons,
                                      text="Reply",
                                      command=self.on_butMsgReply,
                                      )
        self.butMsgReply.pack(side=LEFT)
        self.butMsgDelete = myButton(self.frmButtons,
                                      text="Delete",
                                      command=self.on_butMsgDelete,
                                      )
        self.butMsgDelete.pack(side=LEFT)
                                   
        # Split the rest into splitter panes
        self.panes = myPanedWidget(self.frmTop,
                                   orient='horizontal',
                                   hull_borderwidth=1,
                                   separatorrelief='raised',
                                   hull_height=200,
                                   )
        self.panes.pack(expand=1, fill='both')
    
        #frmPeers = myFrame(self.frmMain)
        #frmPeers.pack(side=LEFT, fill=Y, expand=0)
        frmPeers = self.panes.add("peers", size=.25, min=0.1)
        frmPeers['bg'] = theme.winBgColor
    
        #self.labSelectPeer = myLabel(frmPeers,
        #                             text="Select a peer to connect to",
        #                             )
        #self.labSelectPeer.pack(side=TOP)
    
    
        #scrlPeer = Scrollbar(frmPeers)
        #scrlPeer.pack(side=RIGHT, fill=Y)
    
        #self.lstPeers = Listbox(frmPeers,
        #                        font="helvetica 12",
        #                        bg="white", fg="black",
        #                        height=6,
        #                        selectbackground="blue",
        #                        selectforeground="white",
        #                        yscrollcommand=scrlPeer.set,
        #                        )
    
        #self.listPeers = myListBox(
        #    frmPeers,
        #    #label_text="Known Peers",
        #    #labelpos='nw',
        #    items=()
        #    )
        self.listPeers = treeContacts(frmPeers)
        
        self.listPeers.pack(side=TOP, fill=BOTH, expand=1)
    
        #scrlPeer.config(command=self.lstPeers)
    
        #frmRight = myFrame(self.frmMain)
        #frmRight.pack(side=LEFT, expand=1, fill=BOTH)
        frmRight = self.panes.add("right", size=.75, min=0.1)
        frmRight['bg'] = theme.winBgColor
    
        panesViewer = myPanedWidget(frmRight,
                                   orient='vertical',
                                   hull_borderwidth=1,
                                   separatorrelief='raised')
        panesViewer.pack(fill=BOTH, expand=1)
    
        paneViewTree = panesViewer.add("messages", size=0.5, min=0.1)
        labHeaders = myLabel(paneViewTree,
                             text="Message Headers\n(Not implemented yet)",
                             height=4)
        labHeaders.pack()
    
        paneViewMessage = panesViewer.add("contents", size=0.5, min=0.1)
        labBodies = myLabel(paneViewMessage,
                            text="Message Bodies\n(Not implemented yet)",
                            height=4)
        labBodies.pack()
    
        self.listMessages = myListBox(paneViewTree)
        self.txtMessage = myText(paneViewMessage)
        
        #frmButs = myFrame(frmRight)
        #frmButs.pack(side=TOP, fill=X)
        
        frmLog = myFrame(self.frmBottom, min=0.1, max=0.3)
        frmLog.pack(side=TOP, fill=BOTH, expand=1)
        
        self.labStatus = myLabel(frmLog,
                                 text="Status Log"
                                 )
        self.labStatus.pack(side=TOP)
    
        #self.scrlLog = Scrollbar(frmLog)
        #self.scrlLog.pack(side=RIGHT, fill=Y)
        self.txtLog = myText(
            frmLog,
            )
        #self.txtLog.wm_resizable(1, 1)
        self.txtLog.pack(side=LEFT,
                         expand=1,
                         fill=BOTH)
        #self.scrlLog.config(command=self.txtLog.yview)
    
        # Add application variables
        self.winSession = None
    
    #@-body
    #@-node:4::buildWindows
    #@+node:5::buildMenu
    #@+body
    def buildMenu(self, master):
    
        theme = psst.theme
    
        # Add the menus
        menuTop = myMenu(self.frmMain)
        master.config(menu=menuTop)
    
        menuFile = myMenu(menuTop, "File")
        menuFile.addCmd("Quit", self.on_menuFileQuit, "Control-Q", "Shift-^Q")
    
        menuEdit = myMenu(menuTop, "Edit")
        menuEdit.addCmd("Edit Selected Peer",
                        self.on_menuEditSelectedPeer,
                        "Alt-P", "Alt-P")
        menuEdit.addCmd("Delete Selected Peer",
                        self.on_menuDeleteSelectedPeer, None)
        menuEdit.addCmd("Choose Theme", self.on_menuEditChooseTheme,
                        "Control-T", "Shift-^T")
        menuEdit.addCmd("Settings", self.on_menuEditSettings,
                        "Control-S", "Shift-^S")
    
        menuKeys = myMenu(menuTop, "Keys")
        menuKeys.addCmd("Import Someone's Public Key",
                        self.on_menuKeysImport,
                        "Control-I", "Shift-^I")
        menuKeys.addCmd("Export My Public Key", self.on_menuKeysExport,
                        "Control-E", "Shift-^E")
        menuKeys.addCmd("Change My Passphrase", self.on_menuKeysChangePassphrase,
                        "Control-P", "Shift-^P")
    
        menuHelp = myMenu(menuTop, "Help")
        menuHelp.addCmd("Read Manual", self.on_menuHelpManual,
                        "Control-M", "Shift-Control-M")
        menuHelp.addCmd("About", self.on_menuHelpAbout,
                        "Control-A", "Shift-Control-A")
        menuHelp.addCmd("Report a Bug", self.on_menuHelpReportBug,
                        "Control-B", "Shift-Control-B")
    
        #menuTest = myMenu(menuTop, "Test")
        #menuTest.addCmd("Show Setup Wizard", self.on_menuTestWiz, None)
    
    #@-body
    #@-node:5::buildMenu
    #@+node:6::on_close
    #@+body
    #
    # Event Handlers
    #
    
    def on_close(self, event=None):
    
        psst.config.save()
        psst.running = 0
    
        print "winMain: on_close"
    
        #SSLCrypto._die()
        sys.exit(0)
    
        if self.winSession:
            tkMessageBox.showwarning("Cannot Exit", "Please close all the session windows first")
        else:
            self.win.quit()
        #SSLCrypto._die()
        #self.destroy()
        #print dir(self.frmMain)
        #if self.winSession:
        #    self.winSession.win.quit()
        #self.win.quit()
        
    
    #@-body
    #@-node:6::on_close
    #@+node:7::on_menuFileQuit
    #@+body
    def on_menuFileQuit(self, event=None):
        #print "clicked Exit"
        self.on_close()
    
    
    #@-body
    #@-node:7::on_menuFileQuit
    #@+node:8::on_menuEditSelectedPeer
    #@+body
    def on_menuEditSelectedPeer(self, event=None):
        #print "edit selected peer"
    
        sel = self.listPeers.getvalue()
        if len(sel) != 3 or sel[1] != 'People':
            myMessageBox(
                self.win,
                "No peer selected",
                "You must select a peer to edit",
                'warning',
                ('Close',),
                0)
            return
    
        peer = sel[2]
        result = self.dlgPeer.activate(peer, False)
    
    
    #@-body
    #@-node:8::on_menuEditSelectedPeer
    #@+node:9::on_menuDeleteSelectedPeer
    #@+body
    def on_menuDeleteSelectedPeer(self, event=None):
        """
        Delete a known peer from configuration
        """
        sel = self.listPeers.getvalue()
        if len(sel) != 3 or sel[1] != 'People':
            myMessageBox(None,
                         "No Peer Selected",
                         "Please select a peer first",
                         'warning',
                         ('OK',))
            return
    
        sel = sel[2]
        if myMessageBox(None,
                        "Confirm Delete Peer",
                        "Are you sure you wish to delete peer '%s'?" % sel,
                        'question',
                        ("Yes", "No")) == "Yes":
            #trace()
            del psst.config.peers[sel]
            self.refreshPeers()
        else:
            return
    
    #@-body
    #@-node:9::on_menuDeleteSelectedPeer
    #@+node:10::on_menuEditSettings
    #@+body
    def on_menuEditSettings(self, event=None):
        #print "settings - now running wizard"
        #self.dlgSettings.activate()
    
        if demandpassphrase():
            if self.setupWiz.show():
                myMessageBox(None,
                             "PSST Settings Changed",
                             "Your changes to PSST settings may not\n"
                             +"take effect until you restart PSST",
                             'info',
                             ("OK",))
    
    
    #@-body
    #@-node:10::on_menuEditSettings
    #@+node:11::on_menuEditChooseTheme
    #@+body
    def on_menuEditChooseTheme(self):
        theme = chooseTheme()
        print "chose theme '%s'" % theme
        if theme:
            psst.config.theme = theme
            psst.config.save()
            logMsg("** New theme '%s' will show when you restart this program **" % theme)
    
    #@-body
    #@-node:11::on_menuEditChooseTheme
    #@+node:12::on_menuKeysImport
    #@+body
    def on_menuKeysImport(self, event=None):
        """
        Import a peer's public key
        """
        #print "import someone's public key"
        #path = wx.wxFileSelector("Please choose a file with a PSST public key",
        #                         ".",
        #                         "",
        #                         "psst",
        #                         "*.psst")
        path = askopenfilename(initialdir=".",
                               filetypes=["PSST {.psst}"],
                               title="Import a peer's public key from file..."
                               )
    
        if not path:
            return
        #print "path=", path
    
        kNick = "_unknown_"
        try:
            fd = file(path, "rb")
            kNick = fd.readline().strip()
            kText = fd.read()
            fd.close()
            k = SSLCrypto.key(kText)
        except IOError:
            myMessageBox(self.frmMain, "File System Error",
                         "Error opening public key file '%s'" % path,
                         'error',
                         ('OK',))
            return
        except:
            #wx.wxMessageBox("File '%s' does not appear to contain a valid PSST public key" % path,
            #                "Key Error",
            #                wx.wxICON_ERROR)
            myMessageBox(self.frmMain, "File System Error",
                         "File '%s' does not appear to contain a valid PSST public key" % path,
                         'error',
                         ('OK',))
            return
    
        if myMessageBox(None,
                        "Security Alert!",
                        ("This public key for user '%s' appears valid.\n\n" % kNick)
                           +"However, you need to be absolutely sure that it was\n"
                           +"in fact personally generated and sent by that person,\n"
                           +"and not an intruder mounting a 'Man In The Middle'\n"
                           +"attack and sending you a fake?\n\n"
                           +"If you import a fake key, your privacy will disappear\n\n"
                           +"Are you absolutely sure you want to accept this key?",
                        'question',
                        ("Yes", "No")) != "Yes":
            myMessageBox(None,
                         "Key Rejected",
                         ("Public key for user '%s' rejected.\n\n" % kNick)
                         +"Quite possibly a wise move",
                         'info',
                         ("OK",))
        else:
            psst.config.addPeer(kNick, key=k)
            myMessageBox(None,
                         "Key Import Successful",
                         ("You have accepted user '%s's public key.\n\n" % kNick)
                            +"Please note that if you feel any suspicion,\n"
                            +"you can always delete this key from your\n"
                            +"configuration later on",
                          'info',
                          ('OK',))
            self.refreshPeers()
    
    
    #@-body
    #@-node:12::on_menuKeysImport
    #@+node:13::on_menuKeysExport
    #@+body
    def on_menuKeysExport(self, event=None):
        """
        Export our own public key
        """
        #print "export my public key"
    
        #path = wx.wxFileSelector("Please choose a file to save your public key to",
        #                         ".",
        #                         psst.config.myNick + "-public",
        #                         "psst",
        #                         "*.psst",
        #                         wx.wxSAVE
        #                         )
    
        path = asksaveasfilename(initialdir=".",
                                 filetypes=["PSST {.psst}"],
                                 initialfile=("%s-public.psst" % psst.config.myNick),
                                 title="Save your PSST public key file as..."
                                 )
        #print "you chose '%s'" % path
    
        if not path:
            return
    
        try:
            fd = file(path, "wb")
        except:
            myMessageBox(self.frmMain, "File System Error",
                         "Cannot create file '%s'" % path,
                         'warning',
                         ('OK',))
            return
    
        #pubkey = config.myKey.exportKey(config.myNick)
        pubkey = psst.config.myKey.exportKey()
        fd.write(psst.config.myNick + "\n")
        fd.write(pubkey)
        fd.close()
        #myMessageBox(self.frmMain, "Key export successful",
        #             "Successfully imported your public key to '%s'" % path,
        #             'info',
        #             ('OK',))
        logMsg("Successfully imported your public key as:\n%s\n" % path)
    
    
    #@-body
    #@-node:13::on_menuKeysExport
    #@+node:14::on_menuKeysChangePassphrase
    #@+body
    def on_menuKeysChangePassphrase(self, event=None):
        """
        Changes the config file's passphrase and creates a new
        config locked by the new passphrase
        """
    
        # verify old passphrase first
        if not demandpassphrase():
            return
    
        while 1:
            # Get new passphrase
            result = getpassphrase('PSST Security',
                                   'Please enter a NEW passphrase')
            if result == None:
                myMessageBox(None,
                             "PSST Security",
                             "Passphrase change cancelled",
                             'info',
                             ("OK",))
                return
            pass1 = result
    
            # Prompt again to confirm new passphrase
            result = getpassphrase('PSST Security', 
                                   'Please confirm your new passphrase')
            if result == None:
                return
            pass2 = result
    
            if pass1 != pass2:
                myMessageBox(None,
                             "PSST Security",
                             "Passphrases do not match - passphrase change cancelled",
                             'error',
                             ("OK",))
                return
    
            if pass1 == '':
                if myMessageBox(None,
                                "PSST Security",
                                "You are about to save your config file without a passphrase.\n"
                                 +"Are you really sure you want to do this?",
                                'question',
                                ("Yes","No")) != 'Yes':
                    continue
       
            psst.config.passphrase = pass1
            psst.config.save()
            myMessageBox(None,
                         "PSST Security Confirmation",
                         "Passphrase change successful",
                         "info",
                         ("OK",))
            break
    
    #@-body
    #@-node:14::on_menuKeysChangePassphrase
    #@+node:15::on_menuHelpManual
    #@+body
    def on_menuHelpManual(self, event=None):
        #print "read manual"
    
        if sys.platform == 'win32':
            helpdir = os.path.join(os.getcwd(), "help")
        else:
            helpdir = os.path.join(
                os.path.dirname(os.path.realpath(psst.__file__)), "help")
        
        htmlOpen("file:///%s/frames.html" % helpdir)
    
    
    #@-body
    #@-node:15::on_menuHelpManual
    #@+node:16::on_menuHelpAbout
    #@+body
    def on_menuHelpAbout(self, event=None):
        #print "help about"
        self.dlgHelpAbout.activate()
        #self.aboutDlg.show()
    
    
    #@-body
    #@-node:16::on_menuHelpAbout
    #@+node:17::on_menuHelpReportBug
    #@+body
    def on_menuHelpReportBug(self, event=None):
        #print "report a bug"
        htmlOpen("http://www.freenet.org.nz/bugs")
    
    
    #@-body
    #@-node:17::on_menuHelpReportBug
    #@+node:18::on_menuTestWiz
    #@+body
    def on_menuTestWiz(self):
        result = self.setupWiz.show()
        #print "on_menuTestWiz: result=", result
    
    
    #@-body
    #@-node:18::on_menuTestWiz
    #@+node:19::on_butConnect
    #@+body
    def on_butConnect(self, event=None):
        sel = self.listPeers.getvalue()
        #print "on_butConnect: selected='%s'" % str(sel)
        if len(sel) != 3 or sel[1] != 'People':
            myMessageBox(
                self.win,
                "No peer selected",
                "You must select a specific person to connect to",
                'warning',
                ('Close',),
                0)
            return
    
        peer = sel[2]
    
        result = self.dlgPeer.activate(peer, True)
        #print "on_butConnect: selected=", result
    
    
    #@-body
    #@-node:19::on_butConnect
    #@+node:20::on_butGetMyIP()
    #@+body
    def on_butGetMyIP(self, event=None):
        res = myMessageBox(
            self.win,
            'Anonymity Warning',
            'To determine your IP address accurately, it is necessary\n'
              +'to make a brief HTTP connection to the PSST website on the\n'
              +'Sourceforge.net server.\n\n'
              +'Absolutely no information from your computer will be sent,\n'
              +'but your IP address may be recorded on the Sourceforge.net\n'
              +'server access logs, which will break your anonymity.\n\n'
              +'Do you wish to proceed?',
            "warning",
            ("Sure", "No Way!"),
            0)
        if res == "Sure":
            #print "fetch my ip"
            thread.start_new_thread(self.threadGetMyIP, ())
    
    
    #@-body
    #@-node:20::on_butGetMyIP()
    #@+node:21::on_butMsgGetNew
    #@+body
    def on_butMsgGetNew(self, event=None):
        myMessageBox(
            self.win,
            "Not Implemented",
            "Sorry, this feature hasn't been implemented yet",
            'info',
            ('OK',),
            0)
        return
    
    #@-body
    #@-node:21::on_butMsgGetNew
    #@+node:22::on_butMsgCompose
    #@+body
    def on_butMsgCompose(self, event=None):
        myMessageBox(
            self.win,
            "Not Implemented",
            "Sorry, this feature hasn't been implemented yet",
            'info',
            ('OK',),
            0)
        return
    
    #@-body
    #@-node:22::on_butMsgCompose
    #@+node:23::on_butMsgReply
    #@+body
    def on_butMsgReply(self, event=None):
        myMessageBox(
            self.win,
            "Not Implemented",
            "Sorry, this feature hasn't been implemented yet",
            'info',
            ('OK',),
            0)
        return
    
    #@-body
    #@-node:23::on_butMsgReply
    #@+node:24::on_butMsgDelete
    #@+body
    def on_butMsgDelete(self, event=None):
        myMessageBox(
            self.win,
            "Not Implemented",
            "Sorry, this feature hasn't been implemented yet",
            'info',
            ('OK',),
            0)
        return
    
    #@-body
    #@-node:24::on_butMsgDelete
    #@+node:25::on_ticker
    #@+body
    def on_ticker(self, event=None):
        x, y = self.frmMain.winfo_pointerxy()
        if x != self.xOld or y != self.yOld:
            dx = (x - self.xOld) % 256
            dy = (y - self.yOld) % 256
            SSLCrypto.randomseed(chr(dx) + chr(dy))
            self.xOld, self.yOld = x, y
    
            #print "random: %02x%02x" % (dx, dy)
    
        #print "on_ticker: mouse = (%d,%d)" % (x, y)
        self.frmMain.after(250, self.on_ticker)
    
    #@-body
    #@-node:25::on_ticker
    #@+node:26::threadGetMyIP()
    #@+body
    def threadGetMyIP(self):
        """
        Determine user's IP address via a hit to the PSST website
        on sourceforge.net
        """
    
        logMsg("** IP Address retrieval...")
        logMsg("** Contacting sourceforge.net server...")
    
        try:
            failure = "Reason: unknown"
            conn = httplib.HTTPConnection("netforth.sourceforge.net")
            conn.request("GET", "/cgi-bin/myip2.cgi")
            logMsg("** Fetching http://netforth.sf.net/cgi-bin/myip2.cgi")
            r1 = conn.getresponse()
            if int(r1.status) != 200:
                failure = ("Failed to connect to Sourceforge server:\n"
                           +"Error: %s, reason: %s") % (r1.status, r1.reason)
                raise Exception(failure)
        except:
            myMessageBox(self.win, "HTTP Connection Failure",
                         failure,
                         "warning",
                         ("Close",)
                         )
            return
    
        #print "status='%s'" % r1.status
        #print "reason='%s'" % r1.reason
        ip = r1.read()
        #print "Get My IP: ip='%s'" % ip
        logMsg("** HERE'S YOUR IP ADDRESS:")
        logMsg("    " + ip)
    
    
    
    #@-body
    #@-node:26::threadGetMyIP()
    #@+node:27::on_idle()
    #@+body
    def on_idle(self, event=None):
        """
        Gets triggered when the app needs to check its main event queue
        """
        while not queueMain.empty():
            # Handle messages from our thread
            self.handleMessage(queueMain.get())
    
    #@-body
    #@-node:27::on_idle()
    #@+node:28::refreshPeers
    #@+body
    def refreshPeers(self):
        """
        Refresh the peers list, based on the list in psst.config.peers
        """
        #print "peers: ", psst.config.peers.keys()
    
        items = psst.config.peers.keys()
        #self.listPeers.setlist(items)
        self.listPeers.setPeers(items)
    
        self.listPeers.root.expand()
        self.listPeers.collapsePeers()
        self.listPeers.expandPeers()
        #print dir(self.components.listPeers)
        #self.components.listPeers.foregroundColor = "black"
    
        #self.components.listPeers.Refresh()
    
        #print "list widget has: ", self.components.listPeers.items
    
    
    #@-body
    #@-node:28::refreshPeers
    #@+node:29::showPeerConnected()
    #@+body
    def showPeerConnected(self, peer):
        """
        Updates peers list to show a peer as connected
        """
        peerNode = self.listPeers.find_full_id(('PSST', 'People', peer))
        if peerNode == None:
            print "Weird - can't find peer %s on tree" % peer
            return
        peerNode.set_label("* " + peer)
        return
    
        peer = peer.split(" ")[0]
        peers = self.listPeers.get()
        newpeers = []
        for p in peers:
            if p.split(" ")[0] == peer:
                newpeers.append(peer + " *")
            else:
                newpeers.append(p)
        self.listPeers.setlist(newpeers)
    
    #@-body
    #@-node:29::showPeerConnected()
    #@+node:30::showPeerNotConnected()
    #@+body
    def showPeerNotConnected(self, peer):
        """
        Updates peers list to show a peer as connected
        """
        peerNode = self.listPeers.find_full_id(('PSST', 'People', peer))
        if peerNode == None:
            print "Weird - can't find peer %s on tree" % peer
            return
        peerNode.set_label(peer)
        return
    
        peer = peer.split(" ")[0]
        peers = self.listPeers.get()
        newpeers = []
        for p in peers:
            if p.split(" ")[0] == peer:
                newpeers.append(peer)
            else:
                newpeers.append(p)
        self.listPeers.setlist(newpeers)
    
        if gConnections.has_key(peer):
            del gConnections[peer]
    
    #@-body
    #@-node:30::showPeerNotConnected()
    #@+node:31::handleMessage()
    #@+body
    def handleMessage(self, msgObj):
        #print "handleMessage: received %s" % msgObj
        msgType = msgObj['type']
    
        if msgType == 'gotConnect':
            
            sock = msgObj['sock']
            peer = msgObj['peer']
            host = msgObj['host']
    
            #print "handleMessage: got connection from peer at %s" % addr
            accept = True
            if psst.config.connIncoming == 2:
                # reject automatically
                try:
                    sock.send("0")  # send back a 'no'
                except:
                    pass
                try:
                    sock.close()
                except:
                    pass
                return
            elif psst.config.connIncoming == 1:
                if myMessageBox(
                      self.win,
                      "PSST Incoming Connection",
                      "Got incoming connection from %s\nDo you wish to accept?" % host,
                      'info',
                      ('Yes', 'No')) != 'Yes':
    
                    logMsg("Rejected connection from peer at %s rejected by yourself" % host)
                    try:
                        sock.send("0")  # send back a 'no'
                    except:
                        pass
                    try:
                        sock.close()
                    except:
                        pass
                    return
                else:
                    try:
                        sock.send("1") # send back a 'yes'
                    except:
                        try:
                            sock.close()
                        except:
                            pass
                        return
            elif psst.config.connIncoming == 0: # auto-accept
                sock.send("1")
    
            # Create connection object and session window
            queue = myQueue(size=256, widget=None, callback=None)
            conn = connection(queue, psst.config.myKey, "UNKNOWN", 'tcp', sock)
            sess = winSession(self, queue, None, conn, host)
            queue.widget = sess.frmMain
            queue.callback = sess.on_idle
            logMsg("Accepted connection from %s at %s" % (peer, host))
    
        elif msgType == 'connAccepted':
            # Create connection object
            sock = msgObj['sock']
            nick = msgObj['peer']
            host = msgObj['host']
            port = msgObj['port']
    
            # Create connection object and session window
            queue = myQueue(size=256, widget=None, callback=None)
            conn = connection(queue, psst.config.myKey, nick, 'tcp', sock)
            sess = winSession(self, queue, nick, conn, host, port)
            queue.widget = sess.frmMain
            queue.callback = sess.on_idle
            logMsg("Successfully connected to %s at %s:%s" % (nick, host, port))
            
        elif msgType == 'connRejected':
            msg = "Connection attempt to peer %s at %s:%s rejected:\n%s" % (
                msgObj['peer'], msgObj['host'], msgObj['port'], msgObj['reason'])
            logMsg(msg)
            myMessageBox(self.win, "PSST Connection Failed",
                         msg, 'warning', ("Close",), 0)
            #wx.wxMessageBox(msg, "PSST Connection failed", wx.wxICON_EXCLAMATION)
            self.showPeerNotConnected(msgObj['peer'])
    
        elif msgType == 'connOk':
            logMsg("Peer %s authenticated" % msgObj['peer'])
            self.showPeerConnected(msgObj['peer'])
    
        elif msgType == 'log':
            #print "GOT LOG MESSAGE:", msgObj['text']
            #self.components.fldLog.AppendText(msgObj['text'] + "\n")
            self.txtLog.insert(END, msgObj['text'] + "\n")
            #print "trying to scroll down"
            self.txtLog.component('text').yview(MOVETO, 1.0)
    
    
    #@-body
    #@-node:31::handleMessage()
    #@-others


#@-body
#@-node:1::class winMain
#@+node:2::class winSession
#@+body

class winSession:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, master, queue, nick, conn, host, port=''):
    
        self.buildWindow(master)
        self.bindEvents()
    
        if nick == None:
            nick = 'UNKNOWN'
        self.queue = queue
        self.nick = nick
        self.host = host
        self.port = port
        self.conn = conn
        self.queue = queue
    
        self.resetChallenge()
    
        #print "Session Window opened1"
        self.ctrlPressed = self.shiftPressed = False
    
        # set up voice thread - used for enabling/disabling voice
        self._spin = 0
        self.running = True
        self.clearScreen()
        title = "Now talking to %s at %s:%s" % (self.nick, self.host, self.port)
        if not psst.audioObj:
            #print "no sound!!!"
            title += " (SOUNDCARD UNAVAILABLE)"
        #trace()
        self.win.title(title)
        self.statPeer['text'] = title
    
        if psst.config.connPlaySound:
            psst.playsound(psst.config.connPlaySoundFile)
    
        #print "TESTING - returning from winSession.__init__"
    
        if psst.audioObj:
            self.voiceRxEnabled = 1
            self.chkVoiceRx_v.set(1)
            self.voiceThreshold = 20
            self.voiceQuality = 5
            self.voiceEnabled = 1
            self.toggleVoice()
            self.lockVoice = thread.allocate_lock()
            thread.start_new_thread(self.threadVoice, ())
        else:
            #self.statVoice.settext('Voice disabled (soundcard unavailable)')
            #self.components.statVoice.size = (190, -1)
            pass
            #self.guaVoiceLevel['state'] = DISABLED
            #self.cntVoiceQuality['state'] = DISABLED
            #self.cntVoiceThreshold['state'] = DISABLED
            #self.chkVoiceRx['state'] = DISABLED
            #self.chkVoice['state'] = DISABLED
    
        #self.setupSizers()
    
    
    #@-body
    #@-node:1::__init__
    #@+node:2::bindEvents
    #@+body
    def bindEvents(self):
        """
        Create event bindings for this window
        """
        self.fldTyped.component('text').bind("<Control-s>", self.on_butSend)
        self.fldTyped.component('text').bind("<Control-Return>", self.on_butSend)
        self.win.bind("<Destroy>", self.on_close)
    
        #self.cntVoiceQuality.component('uparrow').bind("<Button-1>", self.on_cntVoiceQuality)
        #self.cntVoiceQuality.component('downarrow').bind("<Button-1>", self.on_cntVoiceQuality)
        #self.cntVoiceThreshold.component('uparrow').bind("<Button-1>", self.on_cntVoiceThreshold)
        #self.cntVoiceThreshold.component('downarrow').bind("<Button-1>", self.on_cntVoiceThreshold)
    
        #w.bind("<Motion>", self.on_motion)
        #self.win.bind("<Return>", self.on_enter_key)
    
        #print "bindEvents: complete"
    
    #@-body
    #@-node:2::bindEvents
    #@+node:3::buildWindow
    #@+body
    def buildWindow(self, master):
        """
        Do all the Tkinter shit work of constructing the window and its widgets
        """
        w = self.win = Toplevel()
        self.parent = master
        #self.win.protocol("WM_CLOSE_WINDOW", self.on_close())
    
        menuTop = myMenu(w)
        w.config(menu=menuTop)
    
        m = myMenu(menuTop, "File")
        m.addCmd("Disconnect", self.on_menuFileClose,
                        "Control-D", "Shift-^D")
        m.addCmd("Send a File", self.on_menuSendFile,
                        "Control-F", "Shift-^F")
    
        m = myMenu(menuTop, "View")
        m.addCmd("Zoom In", self.on_menuZoomIn, "Control-I", "Shift ^I",
                 underline=5)
        m.addCmd("Zoom Out", self.on_menuZoomOut, "Control-O", "Shift ^O",
                 underline=5)
        m.addCmd("Clear Pane", self.on_menuClearPane, "Control-Alt-c", "Alt-^C",
                 underline=0)
    
        mSess = myMenu(menuTop, "Session")
        mChall = myMenu(mSess, "Challenge Peer")
        mChall.addCmd("Choose Paper", self.on_choosePaper, "Control-Alt-p", "Alt-^P",
                      underline=7)
        mChall.addCmd("Choose Scissors", self.on_chooseScissors, "Control-Alt-s",
                      "Alt-^S", underline=7)
        mChall.addCmd("Choose Rock", self.on_chooseRock, "Control-Alt-r",
                      "Alt-^R", underline=7)
        mChall.addCmd("Decline Challenge", self.on_chooseDecline, "Control-Alt-d",
                      "Alt-^d", underline=7)
        
        m = myMenu(menuTop, "Help")
        m.addCmd("Session", self.on_menuHelpSession, "Alt-s", "Alt-S")
    
        #m = myMenu(menuTop, "Test")
        #m.addCmd("Prog", self.on_menuTestProgress, "Alt-p", "Alt P")
    
        f = self.frmMain = myFrame(w)
        f.pack(side=TOP, fill=BOTH, expand=1)
        self.statPeer = myLabel(f, text="Session not open")
        self.statPeer.pack(side=TOP, fill=X, expand=0)
    
        panes = myPanedWidget(f, orient='vertical',
                              hull_borderwidth=1,
                              hull_height=200,
                              separatorthickness=3,
                              separatorrelief='raised',
                              )
        panes.pack(expand=1, fill=BOTH)
    
        ptop = panes.add("top", size=.8, min=.4)
        pbot = panes.add("bottom", size=.2, min=.2)
    
        f1 = myFrame(ptop)
        f1.pack(side=TOP, fill=X)
        f1t = myFrame(f1)
        f1t.pack(side=TOP, fill=X, expand=1)
        f1tL = myFrame(f1t)
        f1tL.pack(side=LEFT, fill=BOTH,expand=1)
    
        f1tR = myFrame(f1t)
        f1tR.pack(side=RIGHT, fill=BOTH,expand=1)
        
        tmp = myFrame(f1tL)
        tmp.pack(side=TOP, fill=X, expand=1)
    
        if psst.audioObj:
            self.chkVoice_v = IntVar()
            v = self.chkVoice = myCheckbutton(tmp,
                                              text="Enable Send Voice",
                                              width=20,
                                              command=self.on_chkVoice,
                                              var=self.chkVoice_v)
            v.pack(side=LEFT)
            #print v.keys()
            self.chkVoiceRx_v = IntVar()
            v = self.chkVoiceRx = myCheckbutton(tmp,
                                                text="Enable Receive Voice",
                                                width=20,
                                                command=self.on_chkVoiceRx,
                                                var=self.chkVoiceRx_v)
            v.pack(side=LEFT)
    
            self.guaVoiceLevel1 = myProgressBar(tmp,
                                                width=60,
                                                height=10,
                                                doLabel=0,
                                                value=0,
                                                )
            self.guaVoiceLevel1.frame.pack(side=LEFT)
            self.progress = 1
    
            #s = self.guaVoiceLevel = myScale(tmp, showvalue=0, width=10)
            #s.pack(side=LEFT, fill=X, expand=1)
    
            s = myLabel(f1tL, text='Voice Sensitivity')
            s.pack(side=LEFT)
            s = self.cntVoiceThreshold = myCounter(
                f1tL,
                datatype='numeric',
                entry_width=3,
                entryfield_value=50,
                entryfield_validate = { 'validator':'integer', 'min':0, 'max':100},
                command=self.on_cntVoiceThreshold,
                )
            s.pack(side=LEFT)
    
            s = self.cntVoiceQuality = myCounter(
                f1tL,
                datatype='numeric',
                entry_width=3,
                entryfield_value=5,
                entryfield_validate = { 'validator':'integer', 'min':0, 'max':10},
                command=self.on_cntVoiceQuality,
                )
            s.pack(side=RIGHT)
            s = myLabel(f1tL, text='Voice Quality')
            s.pack(side=RIGHT)
    
        s = self.txtLog = myText(ptop, font="helvetica")
        #trace()
        self.setFontSize(getattr(psst.config, 'fontSize', 12))
        s.pack(side=TOP, fill=BOTH, expand=1)
    
        panesBot = myPanedWidget(pbot, orient='horizontal',
                                 handlesize=0,
                                 )
        panesBot.pack(expand=1, fill=BOTH)
        
        botL = panesBot.add("l", size=0.8)
    
        s = self.fldTyped = myText(botL)
        s.pack(side=LEFT, fill=Y, expand=1)
    
        botR = panesBot.add("r", size=0.2, min=0.1)
    
        s = self.butSend = myButton(botR,
                                    text="Send",
                                    #width=10,
                                    height=22,
                                    command = self.on_butSend,
                                    )
        s.pack(side=RIGHT, fill=X, expand=1)
        
        #self.win.withdraw()
    
    #@-body
    #@-node:3::buildWindow
    #@+node:4::on_motion
    #@+body
    def on_motion(self, event=None):
        #print "motion: pos=(%d, %d)" % (event.x, event.y)
        pass
    
    #@-body
    #@-node:4::on_motion
    #@+node:5::on_menuSendFile
    #@+body
    def on_menuSendFile(self, event=None):
        #print "send file"
        pass
    
    #@-body
    #@-node:5::on_menuSendFile
    #@+node:6::on_menuFileClose
    #@+body
    def on_menuFileClose(self, event=None):
        self.win.destroy()
        self.on_close()
    
    #@-body
    #@-node:6::on_menuFileClose
    #@+node:7::on_menuZoomIn
    #@+body
    def on_menuZoomIn(self, event=None):
        #print "zoom in"
        size = psst.config.fontSize
        if size < 12:
            size = size + 1
        else:
            size = size * 8/7
        self.setFontSize(size)
    
    #@-body
    #@-node:7::on_menuZoomIn
    #@+node:8::on_menuZoomOut
    #@+body
    def on_menuZoomOut(self, event=None):
        size = psst.config.fontSize
        if size < 12:
            size = size - 1
        else:
            size = size * 7/8
        self.setFontSize(size)
        #print "zoom out"
    
    #@-body
    #@-node:8::on_menuZoomOut
    #@+node:9::on_menuClearPane
    #@+body
    def on_menuClearPane(self, event=None):
        #print "clear pane"
        self.txtLog.settext('')
    
    
    #@-body
    #@-node:9::on_menuClearPane
    #@+node:10::on_menuHelpSession
    #@+body
    def on_menuHelpSession(self, event=None):
        #print "help on session"
        pass
    
    
    #@-body
    #@-node:10::on_menuHelpSession
    #@+node:11::on_butSend
    #@+body
    def on_butSend(self, event=None):
        #trace()
        if self.conn.state == 'closed':
            self.writeScreen("*** NO CONNECTION", "red")
            return
    
        txt = self.fldTyped.getvalue()
        self.conn.send('T', txt)
        self.writeScreen("%s> %s\n" % (psst.config.myNick, txt), psst.theme.chatMyTypingColor)
    
        #fldTyped.setFocus()
        #print "send"
    
        self.queue.put({'type':'cleartyped'})
    
    
    #@-body
    #@-node:11::on_butSend
    #@+node:12::on_close
    #@+body
    def on_close(self, event=None):
        if self.win:
            #self.win.quit()
            self.win = None
            self.parent.winSession = None
            #print "closed winsession"
    
    
    #@-body
    #@-node:12::on_close
    #@+node:13::on_enter_key
    #@+body
    def on_enter_key(self, event=None):
        #print "pressed enter: event=", event
        #trace()
        pass
    
    #@-body
    #@-node:13::on_enter_key
    #@+node:14::on_close()
    #@+body
    def on_close(self, event=None):
        #print "got close"
        if self.conn.state != 'closed':
            logMsg("Connection with %s closed by yourself" % self.conn.peer)
        self.running = False
        self.conn.close()
        #event.Skip()
    
    
    
    #@-body
    #@-node:14::on_close()
    #@+node:15::on_menuFileDisconnect_select
    #@+body
    def on_menuFileDisconnect_select(self, event):
        self.Close()
    
    #@-body
    #@-node:15::on_menuFileDisconnect_select
    #@+node:16::on_menuSessionSendLine_select()
    #@+body
    def on_menuSessionSendLine_select(self, event):
        """
        Receives Ctrl-S to send line fo text (if non-empty)
        """
        self.on_butSend_mouseClick(event)
    
    #@-body
    #@-node:16::on_menuSessionSendLine_select()
    #@+node:17::on_menuHelpSession_select()
    #@+body
    def on_menuHelpSession_select(self, event):
        winHelp.Show(self, "session.html")
    
    #@-body
    #@-node:17::on_menuHelpSession_select()
    #@+node:18::on_menuTestProgress
    #@+body
    def on_menuTestProgress(self, event=None):
        self.guaVoiceLevel1.updateProgress(self.progress)
        self.progress += 5
    
    #@-body
    #@-node:18::on_menuTestProgress
    #@+node:19::on_chkVoice
    #@+body
    def on_chkVoice(self, event=None):
        self.toggleVoice()
        #print "clicked on chkVoice"
    
    
    #@-body
    #@-node:19::on_chkVoice
    #@+node:20::on_chkVoiceRx
    #@+body
    def on_chkVoiceRx(self, event=None):
        self.voiceRxEnabled = self.chkVoiceRx_v.get()
        if self.voiceRxEnabled:
            print "Enabled receive voice"
        else:
            print "Disabled receive voice"
    
    #@-body
    #@-node:20::on_chkVoiceRx
    #@+node:21::on_fldTyped_keyPress
    #@+body
    def on_fldTyped_keyPress(self, event):
        # allow a lazy CR instead of explicit button click
        #print "key pressed: ", event.keyCode
        # Discovered this trick by trial and error - no
        # mention of it in any doco :(
        # pass any non-CR keystrokes 'upstream'
        event.Skip()
        if event.keyCode == 13 and self.ctrlPressed:
            #print "Pressed Ctrl-Enter"
            self.on_butSend_mouseClick(event)
    
    #@-body
    #@-node:21::on_fldTyped_keyPress
    #@+node:22::on_fldTyped_keyDown
    #@+body
    def on_fldTyped_keyDown(self, event):
        #print "key down: ", event.keyCode
        if event.keyCode == 308: # control key
            #print "ctrl down"
            self.ctrlPressed = 1
        elif event.keyCode == 306: # shift key
            self.shiftPressed = 1
        if self.shiftPressed and self.ctrlPressed:
            self.toggleVoice()
        event.Skip()
    
    #@-body
    #@-node:22::on_fldTyped_keyDown
    #@+node:23::on_fldTyped_keyUp
    #@+body
    def on_fldTyped_keyUp(self, event):
        #print "key up: ", event.keyCode
        if event.keyCode == 308: # control key
            #print "ctrl up"
            self.ctrlPressed = 0
        elif event.keyCode == 306: # shift key
            self.shiftPressed = 0
        event.Skip()
    
    #@-body
    #@-node:23::on_fldTyped_keyUp
    #@+node:24::on_cntVoiceQuality
    #@+body
    def on_cntVoiceQuality(self, event, val=None):
    
        #self.voiceQuality = int(self.cntVoiceQuality.component('entryfield').getvalue())
        self.voiceQuality = val
        psst.audioObj.setQuality(self.voiceQuality)
        #print "val=%s" % val
        #print "changed voice quality to %d" % self.voiceQuality
    
    
    #@-body
    #@-node:24::on_cntVoiceQuality
    #@+node:25::on_cntVoiceThreshold
    #@+body
    def on_cntVoiceThreshold(self, event, val=None):
        #self.voiceThreshold = 100 - int(self.cntVoiceThreshold.component('entryfield').getvalue())
        self.voiceThreshold = 100 - val
        #print "Changed voice threshold to %d" % self.voiceThreshold
        #print "val=%s" % val
        #self.components.guaVoiceLevel.SetValue(self.voiceThreshold)
    
    
    #@-body
    #@-node:25::on_cntVoiceThreshold
    #@+node:26::setFontSize
    #@+body
    def setFontSize(self, size):
        self.txtLog.component('text')['font'] = "helvetica %d" % size
        psst.config.fontSize = size
        #print "setFontSize: set size to %d" % size
    
    
    #@-body
    #@-node:26::setFontSize
    #@+node:27::toggleVoice()
    #@+body
    def toggleVoice(self):
        try:
            self.voiceEnabled = not self.voiceEnabled
        except:
            return
        self.chkVoice_v.set(self.voiceEnabled)
    
        # drain the audio input buffer
        if psst.audioObj:
            psst.audioObj.readCompressed()
        if self.voiceEnabled:
            print "toggleVoice: Enabled send voice"
        else:
            self.chkVoice['bg'] = theme.chkBgColor
    
            self.guaVoiceLevel1.updateProgress(0)
            #print "FIX THE FUCKING VOICE LEVEL GAUGE!!"
            #self.components.guaVoiceLevel.SetValue(0)
            #self.Refresh()
            #print "toggleVoice: Disabled send voice"
    
    
    #@-body
    #@-node:27::toggleVoice()
    #@+node:28::writeScreen
    #@+body
    def writeScreen(self, msg, color='#000000'):
    
        #h = "<font size=1 color=\"%s\">%s</font><br>\n" \
        #    % (color, self._hackHtml(msg))
        #self.components.txtLog.Append(h)
    
        #print "writeScreen: got '%s'" % msg
        try:
            self.txtLog.tag_config(color, foreground=color)
            self.txtLog.insert(END, msg.strip() + "\n", color)
            self.txtLog.component('text').yview(MOVETO, 1.0)
        except:
            print "writeScreen: exception - screen must be closed"
    
    
    #@-body
    #@-node:28::writeScreen
    #@+node:29::_hackHtml()
    #@+body
    def _hackHtml(self, buf):
        """
        Processes buffer and converts html chars into escapes.
        Also creates link tags for perceived URLs
        """
        buf = buf.replace("&", "&amp;")
        buf = buf.replace("<", "&lt;")
        buf = buf.replace(">", "&gt;")
        buf = self._hackHtmlUrls(buf)
        return buf
    
    def _hackHtmlUrls(self, buf):
    
        if buf > '':
            m = reUrls.search(buf)
            if m:
                start, end = m.span()
                pre = buf[0:start]
                url = buf[start:end]
                if url[0:7] != 'http://':
                    url1 = 'http://' + url
                else:
                    url1 = url
                post = self._hackHtmlUrls(buf[end:])
                buf = pre + "<A HREF=\"%s\">%s</A>" % (url1, url) + post
        return buf
    
    #@-body
    #@-node:29::_hackHtml()
    #@+node:30::clearScreen
    #@+body
    def clearScreen(self):
        self.txtLog.clear()
    
    #@-body
    #@-node:30::clearScreen
    #@+node:31::on_idle()
    #@+body
    def on_idle(self, event=None):
        while not self.queue.empty():
            # Handle messages from our thread
            self.handleMessage(self.queue.get())
        #event.Skip()
    
    
    #@-body
    #@-node:31::on_idle()
    #@+node:32::on_choosePaper
    #@+body
    def on_choosePaper(self, event=None):
        self.sendChallenge('paper')
    
    #@-body
    #@-node:32::on_choosePaper
    #@+node:33::on_chooseScissors
    #@+body
    def on_chooseScissors(self, event=None):
        self.sendChallenge('scissors')
    
    #@-body
    #@-node:33::on_chooseScissors
    #@+node:34::on_chooseRock
    #@+body
    def on_chooseRock(self, event=None):
        self.sendChallenge('rock')
    
    #@-body
    #@-node:34::on_chooseRock
    #@+node:35::on_chooseDecline
    #@+body
    def on_chooseDecline(self, event=None):
        self.sendChallenge('decline')
        self.resetChallenge()
    
    
    #@-body
    #@-node:35::on_chooseDecline
    #@+node:36::sendChallenge
    #@+body
    def sendChallenge(self, choice):
    
        if self.challengeSent:
            self.writeScreen("You've already sent a challenge - please await response",
                             psst.theme.chatErrorColor)
            return
    
        #print "Sending '%s'" % choice
        self.conn.send('p', choice)
        if choice == 'decline':
            self.writeScreen("You declined %s's challenge" % self.nick,
                             psst.theme.chatErrorColor)
            self.resetChallenge()
        else:
            self.challengeSent = choice
            if self.challengeReceived:
                self.judgeChallenge()
            else:
                self.writeScreen("Waiting for %s's response to your challege" % self.nick,
                                 psst.theme.chatErrorColor)
    
    
    #@-body
    #@-node:36::sendChallenge
    #@+node:37::judgeChallenge
    #@+body
    def judgeChallenge(self):
        """
        Judge and announce results for a 'paper/scissors/rock' challenge.
        """
    
        if self.challengeReceived and self.challengeSent:
            self.writeScreen("You  sent %s" % self.challengeSent,
                             psst.theme.chatErrorColor)
            self.writeScreen("%s sent %s" % (self.nick, self.challengeReceived),
                             psst.theme.chatErrorColor)
            if self.challengeReceived == self.challengeSent:
                self.writeScreen("Result: DRAW!")
            elif self.challengeSent == 'paper':
                if self.challengeReceived == 'rock':
                    self.writeScreen("Paper covers rock - YOU WIN!",
                                     psst.theme.chatErrorColor)
                else:
                    self.writeScreen("Scissors cut paper - YOU LOSE!",
                                     psst.theme.chatErrorColor)
            elif self.challengeSent == 'scissors':
                if self.challengeReceived == 'rock':
                    self.writeScreen("Rock blunts scissors - YOU LOSE!",
                                     psst.theme.chatErrorColor)
                else:
                    self.writeScreen("Scissors cut paper - YOU WIN!",
                                     psst.theme.chatErrorColor)
            elif self.challengeSent == 'rock':
                if self.challengeReceived == 'paper':
                    self.writeScreen("Paper covers rock - YOU LOSE!",
                                     psst.theme.chatErrorColor)
                else:
                    self.writeScreen("Rock blunts scissors - YOU WIN!",
                                     psst.theme.chatErrorColor)
        self.resetChallenge()
    
    
    #@-body
    #@-node:37::judgeChallenge
    #@+node:38::resetChallenge
    #@+body
    def resetChallenge(self):
        self.challengeReceived = self.challengeSent = None
    
    #@-body
    #@-node:38::resetChallenge
    #@+node:39::handleMessage()
    #@+body
    def handleMessage(self, msg):
        """
        Handles incoming events on this connection
        """
        #print "winSession.handleMessage: received: ", msg
        msgType = msg['type']
        if msgType == 'connClose':
            self.writeScreen("*** Connection Closed: %s\n" \
                               % msg['reason'], psst.theme.chatErrorColor)
    
            logMsg("Peer connection to %s closed at their end" \
                   % self.nick)
    
        elif msgType == 'connOK':
            self.nick = self.conn.peer
            self.writeScreen("*** Peer %s authenticated successfully\n" \
                             % self.nick,
                             psst.theme.chatOKColor)
    
            self.title = "Now talking to %s at %s:%s" % (
                self.nick, self.host, self.port)
            if not psst.audioObj:
                self.title += " (SOUNDCARD UNAVAILABLE)"
            self.statPeer['text'] = self.title
            self.win.title(self.title)
    
        elif msgType == 'status':
            self.writeScreen("**** %s\n" % msg['text'], psst.theme.chatMsgColor)
    
        elif msgType == 'cleartyped':
            self.fldTyped.setvalue('')
    
        elif msgType == 'rxdata':
            rxtype = msg['rxtype']
            data = msg['data']
            if rxtype == 'T':
                self.writeScreen("%s> %s\n" % (self.nick, data),
                                 psst.theme.chatPeerTypingColor)
    
            elif rxtype == 'V':
                if psst.voxtest:
                    # pass to echo tester
                    self._voxtestHandleVoice(data)
                elif psst.audioObj:
                    # play it to system audio output
                    psst.audioObj.writeCompressed(data)
                else:
                    # drop voice packet - soundcard is not happening
                    pass
            elif rxtype == 'p':
                #print "received challenge from peer: %s" % data
                if data == 'decline':
                    self.writeScreen("%s declined your challenge" % self.nick,
                                     psst.theme.chatErrorColor)
                    self.resetChallenge()
                else:
                    self.challengeReceived = data
                    if self.challengeSent:
                        self.judgeChallenge()
                    else:
                        self.writeScreen(("%s has issued a Paper/Scissors/Rock challenge.\n"
                                         +"Please send a response (from Menu->Session->Challenge") \
                                              % self.nick,
                                         psst.theme.chatErrorColor)
    
                #self.writeScreen("%s sent %s" % (self.nick, data),
                #                 psst.theme.chatPeerTypingColor)
            else:
                self.writeScreen("Unknown data from %s:\n%s" % (self.nick, str(data)),
                                 psst.theme.chatPeerTypingColor)
    
        elif msgType == 'voxui':
            try:
                guage = msg['guage']
                if guage > self.voiceThreshold or self.prevgua > self.voiceThreshold:
                    #print "handleMessage: voice level=%s" % guage
                    self.chkVoice['bg'] = theme.chatVoxSendBgColor
                    self.chkVoice['fg'] = theme.chatVoxSendFgColor
                else:
                    self.chkVoice['bg'] = theme.chkBgColor
                    self.chkVoice['fg'] = theme.chkFgColor
                    #self.chkVoice['bg'] = "#D8D8D8"
                self.prevgua = guage
                #self.guaVoiceLevel.set(guage)
                self.guaVoiceLevel1.updateProgress(guage)
                #self.Refresh()
            except:
                pass
    
        elif msgType == 'scroll':
            #print "winSession.handleMeesage:trying to scroll"
            #h = self.components.txtLog
            #h.Scroll(-1, h.GetVirtualSize()[1])
            pass
    
        else:
            self.writeScreen("*** Unknown queue message: %s\n" % msgType,
                             psst.theme.chatErrorColor)
    
    
    
    
    
    #@-body
    #@-node:39::handleMessage()
    #@+node:40::threadVoice()
    #@+body
    def threadVoice(self):
        """
        Thread which (when voice is enabled) listens for audio data
        then enqueues this for encoding and transmission
        """
        #print "winSession: threadVoice launched"
        waittime = 0.1
        try:
            self.prevgua = 0
            while self.running and psst.running:
                #print "threadVoice: "
                #self.lockVoice.acquire()
                if self.voiceEnabled:
                    #print "before readcompressed"
                    seg = psst.audioObj.readCompressed()
                    #print "after readcompressed"
                    if seg:
                        waittime = 0.1
                        amp = psst.audioObj.amplitude(seg, 0.1)
                        try:
                            gua = math.log(amp) * 13
                        except:
                            gua = 1
                        if gua > 100:
                            gua = 100
                        if gua < 1:
                            gua = 1
                        try:
                            if gua > self.voiceThreshold or self.prevgua > self.voiceThreshold:
                                #print "sent compressed voice fragment, len %d, amplitude %8.1f" % (
                                #    len(seg), amp)
                                self.conn.send('V', seg)
                                #self.components.chkVoice.backgroundColor = "#00FF00"
                            else:
                                #self.components.chkVoice.backgroundColor = "#C8C8C8"
                                #print "insufficient volume: not sending"
                                pass
                        except:
                            #print "threadVoice: connection is closed, exiting"
                            raise
    
                        self.queue.put({'type':'voxui', 'guage':gua})
                        #wx.wxWakeUpIdle()
    
                        # test - local echo without encrypting/sending/receiving
                        #self._voxFIFO.append(seg)
                        #if len(self._voxFIFO) >= 20:
                        #    psst.audioObj.writeCompressed(self._voxFIFO.pop(0))
                    else:
                        time.sleep(waittime)
                        if waittime <= 2:
                            waittime = waittime * 2
                else:
                    time.sleep(1)
                    #print "threadVoice: ticking..."
                #self.lockVoice.release()
        except:
            raise
            pass
    
    
    #@-body
    #@-node:40::threadVoice()
    #@+node:41::_voxtestHandleVoice()
    #@+body
    _voxFIFO = []
    
    def _voxtestHandleVoice(self, segment):
        """
        Temporary test handler for incoming voice.
    
        Stores voice segments into a FIFO, and once a certain number
        of fragments have been received, sends back the first one
        """
        #print "_voxtestHandleVoice: adding voice fragment"
        self._voxFIFO.append(segment)
        if len(self._voxFIFO) >= 4:
            #print "_voxtestHandleVoice: sending back voice fragment, len %d" % len(segment)
            self.conn.send('V', self._voxFIFO.pop(0))
    
    #@-body
    #@-node:41::_voxtestHandleVoice()
    #@-others


#@-body
#@-node:2::class winSession
#@-node:1::Windows
#@+node:2::Specific Widgets
#@+node:1::class treeContacts
#@+body
class treeContacts(Tree.Tree):

    def __init__(self, parent):
        Tree.Tree.__init__(self, parent,
                           rootId="PSST", rootLabel="PSST")
        self.hasTopLevel = 0
        self.nodeGroup = []
        self.namesGroup = []
        self.nodePeople = []
        self.namesPeople = []
        self.selectedNode = ()

    def on_select(self, node):
        print "select_callback: id='%s'" % str(node.full_id())
    
    def getChildren(self, node):

        full_id = node.full_id()
        print "getChildren: node.full_id='%s'" % str(node.full_id())
        if not self.hasTopLevel:
            # set up data structure
            self.hasTopLevel = 1
            pass

        if full_id == ('PSST',):
            self.add_node(name="Groups", id="Groups", flag=1)
            self.add_node(name="People", id="People", flag=1)
        elif full_id == ('PSST', 'People'):
            for name in self.namesPeople:
                self.add_node(name=name, id=name, flag=0)

    def setPeers(self, items):
        self.namesPeople = items
        print "setPeers: items='%s'" % items

    def getvalue(self):
        return self.selectedNode

    def expandGroups(self):
        self.find_full_id(('PSST', 'Groups')).expand()

    def expandPeers(self):
        self.find_full_id(('PSST', 'People')).expand()

    def collapsePeers(self):
        self.find_full_id(('PSST', 'People')).collapse()

#@-body
#@-node:1::class treeContacts
#@+node:2::class treeMessages
#@+body
class treeMessages(Tree.Tree):

    def __init__(self, parent):
        Tree.Tree.__init__(self, parent,
                           rootId="Messages", rootLabel="Messages")
        self.hasTopLevel = 0
        self.nodeGroup = []
        self.namesGroup = []
        self.nodePeople = []
        self.namesPeople = []
        self.selectedNode = ()

    def on_select(self, node):
        print "select_callback: id='%s'" % str(node.full_id())
    
    def getChildren(self, node):

        full_id = node.full_id()
        print "getChildren: node.full_id='%s'" % str(node.full_id())
        if not self.hasTopLevel:
            # set up data structure
            self.hasTopLevel = 1
            pass

        if full_id == ('Messages',):
            self.add_node(name="From Groups", id="Groups", flag=1)
            self.add_node(name="From People", id="People", flag=1)
        elif full_id == ('Messages', 'People'):
            for name in self.namesPeople:
                self.add_node(name=name, id=name, flag=1)

    def setPeers(self, items):
        self.namesPeople = items
        print "setPeers: items='%s'" % items

    def getvalue(self):
        return self.selectedNode

    def expandGroups(self):
        self.find_full_id(('Messages', 'Groups')).expand()

    def expandPeers(self):
        self.find_full_id(('Messages', 'People')).expand()

    def collapsePeers(self):
        self.find_full_id(('Messages', 'People')).collapse()

#@-body
#@-node:2::class treeMessages
#@-node:2::Specific Widgets
#@+node:3::Customised Generic Widgets
#@+node:1::Classes
#@+node:1::class myMenu
#@+body
class myMenu(Menu):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, label=None, tearoff=0, **args):
        Menu.__init__(self, parent,
                      font="helvetica 10",
                      tearoff=tearoff,
                      **args)
        if label != None:
            parent.add_cascade(label=label, menu=self)
    
        self['bg'] = theme.menuBgColor
        self['fg'] = theme.menuFgColor
        self['font'] = theme.menuFont
        self['activebackground'] = theme.menuActiveBgColor
        self['activeforeground'] = theme.menuActiveFgColor
    
    #@-body
    #@-node:1::__init__
    #@+node:2::add_cascade
    #@+body
    def add_cascade(self, underline=0, **args):
        Menu.add_cascade(self, underline=0, **args)
    
    #@-body
    #@-node:2::add_cascade
    #@+node:3::add_command
    #@+body
    def add_command(self, underline=0, **args):
        Menu.add_command(self, underline=0, **args)
    
    #@-body
    #@-node:3::add_command
    #@+node:4::addCmd
    #@+body
    def addCmd(self, label, action, shortcut, abbrev='', **args):
        self.add_command(label=label,
                         accelerator=abbrev,
                         command=action,
                         **args)
        if shortcut != None:
            self.bind_all("<%s>" % shortcut, action)
        
    
    #@-body
    #@-node:4::addCmd
    #@-others


#@-body
#@-node:1::class myMenu
#@+node:2::class myLabel
#@+body
class myLabel(Label):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, font="helvetica 10", **args):
        theme = psst.theme
    
        height = takeKey(args, 'height', 1)
        Label.__init__(self, parent,
                       #font=font,
                       bg=theme.labBgColor,
                       fg=theme.labFgColor,
                       font=theme.labFont,
                       height=height,
                       **args)
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:2::class myLabel
#@+node:3::class myButton
#@+body

class myButton(Button):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        theme = psst.theme
        Button.__init__(self, parent,
                        font=theme.butFont,
                        bg=theme.butBgColor,
                        fg=theme.butFgColor,
                        **args)
        self.config(
            background=theme.butBgColor,
            foreground=theme.butFgColor,
            #selectColor=theme.butSelColor,
            activeforeground=theme.butActiveFgColor,
            activebackground=theme.butActiveBgColor,
            highlightbackground=theme.butHighlightColor,
            #selectBackground=theme.butActiveBgColor,
            #highlightColor=theme.butActiveFgColor,
            #selectForeground=theme.butSelColor,
            #disabledForeground=theme.tkDisabledFgColor,
            #insertBackground=theme.tkInsBgColor,
            #troughColor=theme.tkTroughColor
            )
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:3::class myButton
#@+node:4::class myCheckbutton
#@+body

class myCheckbutton(Checkbutton):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        theme = psst.theme
        bg = takeKey(args, 'bg', theme.chkBgColor)
        fg = takeKey(args, 'fg', theme.chkFgColor)
        font = takeKey(args, 'font', theme.chkFont)
    
        if sys.platform == 'win32':
            theme.chkSelColor = theme.chkBgColor
    
        Checkbutton.__init__(self, parent,
                             onvalue=1, offvalue=0,
                             bg=bg,
                             fg=fg,
                             font=font,
                             justify=LEFT,
                             anchor=W,
                             selectcolor=theme.chkSelColor,
                             highlightcolor=theme.frmBgColor,
                             highlightbackground=theme.frmBgColor,
                             activeforeground=theme.chkActiveFgColor,
                             activebackground=theme.chkActiveBgColor,
                             **args)
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:4::class myCheckbutton
#@+node:5::class myText
#@+body

class myText(Pmw.ScrolledText):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        theme = psst.theme
        
        bg = takeKey(args, 'bg', 'white')
        font = takeKey(args, 'font', 'helvetica 12')
    
        Pmw.ScrolledText.__init__(
            self, parent,
            **args)
        self.component('text').config(
            #bg=bg,
            #font=font,
            bg=theme.textBgColor,
            fg=theme.textFgColor,
            font=theme.textFont,
            insertbackground=theme.textFgColor,
            insertwidth=5,
            selectbackground=theme.textSelBgColor,
            selectforeground=theme.textSelFgColor,
            
            borderwidth=0,
            wrap=WORD,
            )
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:5::class myText
#@+node:6::class myScale
#@+body

class myScale(Scale):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, orient='horizontal', **args):
        Scale.__init__(self, parent,
                       #bg="red",
                       orient=orient,
                       **args)
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:6::class myScale
#@+node:7::class myEntry
#@+body

class myEntry(Pmw.EntryField):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        theme = psst.theme
        
        font = takeKey(args, 'font', theme.entryFont)
        bg = takeKey(args, 'bg', theme.entryBgColor)
        fg = takeKey(args, 'fg', theme.entryFgColor)
    
        width = takeKey(args, 'width', 8)
        
        Pmw.EntryField.__init__(
            self, parent,
            **args)
    
        try:
            self.component('entry').config(
                bg=bg,
                fg=fg,
                font=font,
                width=width,
                selectforeground=fg,
                selectbackground=theme.entrySelColor,
                #activebackground=bg,
                disabledbackground=theme.entryBgColor,
                #disabledforeground=theme.entryDisabledFgColor,
                disabledforeground='white',
                highlightcolor=theme.labBgColor,
                highlightbackground=theme.labBgColor,
                insertbackground=fg,
                )
        except:
            self.component('entry').config(
                bg=bg,
                fg=fg,
                font=font,
                width=width,
                selectforeground=fg,
                selectbackground=theme.entrySelColor,
                #activebackground=bg,
                highlightcolor=theme.labBgColor,
                highlightbackground=theme.labBgColor,
                insertbackground=fg,
                )
    
        self.component('hull').config(
            bg=bg,
            highlightcolor=fg,
            highlightbackground=bg,
            )
    
        try:
            lab = self.component('label')
        except:
            return
    
        #print "configuring label for field"
        if lab:
            try:
                self.component('label').config(
                    #borderwidth=0,
                    bg=theme.labBgColor,
                    fg=theme.labFgColor,
                    font=theme.labFont,
                    #disabledbackground=theme.entryBgColor,
                    disabledforeground=theme.entryDisabledFgColor,
                    highlightcolor=theme.labBgColor,
                    highlightbackground=theme.labBgColor,
                    )
            except:
                self.component('label').config(
                    #borderwidth=0,
                    bg=theme.labBgColor,
                    fg=theme.labFgColor,
                    font=theme.labFont,
                    #disabledbackground=theme.entryBgColor,
                    highlightcolor=theme.labBgColor,
                    highlightbackground=theme.labBgColor,
                    )
                
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:7::class myEntry
#@+node:8::class myComboBox
#@+body

class myComboBox(Pmw.ComboBox):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        theme = psst.theme
        Pmw.ComboBox.__init__(self, parent, **args)
    
        self.component('entryfield').component('entry').config(
            background=theme.cmbBgColor,
            foreground=theme.cmbFgColor,
            highlightbackground=theme.frmBgColor,
            )
        l = self.component('scrolledlist').component('listbox')
        #print l.keys()
        l.config(
            background=theme.cmbBgColor,
            foreground=theme.cmbFgColor,
            highlightbackground=theme.frmBgColor,
            selectbackground=theme.cmbSelBgColor,
            selectforeground=theme.cmbSelFgColor,
            )
        self.component('arrowbutton').config(
            bg=theme.cmbBgColor,
            highlightbackground=theme.frmBgColor,
            )
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:8::class myComboBox
#@+node:9::class myRadiobutton
#@+body
class myRadiobutton(Radiobutton):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **args):
        print "radiobutton!!!!!!!!!!!!!!!!!!!!!!!!!!"
        Radiobutton.__init__(self, parent,
                             selectcolor=theme.radSelColor,
                             highlightcolor=theme.frmBgColor,
                             highlightbackground=theme.frmBgColor,
                             activeforeground=theme.radActiveFgColor,
                             activebackground=theme.radActiveBgColor,
                             font="helvetica 10",
                             **args)
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:9::class myRadiobutton
#@+node:10::class myListBox
#@+body
class myListBox(Pmw.ScrolledListBox):
    """
    Customised for appearance
    """

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **kwds):
        theme = psst.theme
        Pmw.ScrolledListBox.__init__(self, parent, **kwds)
        self.component('listbox').config(
            bg=theme.listBgColor,
            fg=theme.listFgColor,
            selectbackground=theme.listSelBgColor,
            selectforeground=theme.listSelFgColor,
            highlightbackground=theme.listBgColor,
            font=theme.listFont,
            )
        try:
            self.component('label').config(
                bg=theme.labBgColor,
                fg=theme.labFgColor,
                font=theme.labFont,
                )
        except:
            pass
    
        try:
            self.component('hull').config(
                bg=theme.frmBgColor,
                )
        except:
            pass
    
        try:
            self.component('horizscrollbar').config(
                bg=theme.scrlBgColor,
                activebackground=theme.scrlBgActiveColor,
                )
        except:
            raise
            pass
    
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:10::class myListBox
#@+node:11::class myQueue
#@+body
class myQueue(Queue.Queue):
    """
    Tk-ised version of Queue that gets created with a widget ref and a
    callback function.

    Upon writing to the queue, the widget will get spiked with an 'after'
    call, to trigger its callback
    """

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, **args):
        Queue.Queue.__init__(self, args.get("size", 32))
        self.widget = args['widget']
        self.callback = args['callback']
    
    
    #@-body
    #@-node:1::__init__
    #@+node:2::put
    #@+body
    def put(self, thing):
        Queue.Queue.put(self, thing)
        try:
            time.sleep(0.05)
            self.widget.after(10, self.callback)
        except:
            #trace()
            print "QUEUEING MESSAGE, cannot wakeup window -", thing
            pass
    
    
    #@-body
    #@-node:2::put
    #@-others


#@-body
#@-node:11::class myQueue
#@+node:12::class myCounter
#@+body
class myCounter(Pmw.Counter):
    """
    Supports a 'command' option
    """

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent, **kwds):
        theme = psst.theme
        self.callback = takeKey(kwds, 'command', None)
        self.datatype = takeKey(kwds, 'datatype', 'numeric')
        self.min = kwds.get('entryfield_validate').get('min', 0)
        self.max = kwds.get('entryfield_validate').get('max', 100)
        Pmw.Counter.__init__(self, parent, datatype=self.on_change, **kwds)
        self.component('uparrow').config(
            bg = theme.cntBgColor,
            borderwidth=0,
            #fg = theme.entryFgColor,
            highlightcolor=theme.cntBgColor,
            highlightbackground=theme.cntBgColor,
            )
        self.component('downarrow').config(
            bg = theme.cntBgColor,
            borderwidth=0,
            #fg = theme.entryFgColor,
            highlightcolor=theme.cntBgColor,
            highlightbackground=theme.cntBgColor,
            )
        self.component('hull').config(
            bg = theme.cntFgColor,
            borderwidth=0,
            highlightcolor=theme.cntBgColor,
            highlightbackground=theme.cntBgColor,
            )
        ef = self.component('entryfield').component('entry')
        #print ef.keys()
        ef.config(
            borderwidth=0,
            fg=theme.cntFgColor,
            bg=theme.cntBgColor,
            highlightcolor=theme.cntBgColor,
            highlightbackground=theme.cntBgColor,
            )
    
    def on_change(self, text, factor, increment, *args):
        val = int(text)
        newval = val + (factor * increment)
        if newval >= self.min and newval <= self.max:
            if self.callback:
                self.callback(self, newval)
            return newval
        else:
            return val
    
    
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:12::class myCounter
#@+node:13::class myNotebook
#@+body
class myNotebook(Pmw.NoteBook):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, master, **kwds):
    
        Pmw.NoteBook.__init__(self, master,
                              pagemargin=0,
                              **kwds)
    
    #@-body
    #@-node:1::__init__
    #@+node:2::add
    #@+body
    def add(self, name, **kw):
        page = Pmw.NoteBook.add(self, name, **kw)
        page.config(
            bg=psst.theme.frmBgColor
            )
        return page
    
    #@-body
    #@-node:2::add
    #@-others


#@-body
#@-node:13::class myNotebook
#@+node:14::class myDialog
#@+body
class myDialog(Pmw.Dialog):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, master, **kwds):
        Pmw.Dialog.__init__(self, master, **kwds)
        
        self.component('dialogchildsite').config(bg=theme.frmBgColor)
    
        box = self.component('buttonbox')
        box.component('hull').config(
            bg=psst.theme.frmBgColor
            )
    
        nbuts = box.numbuttons()
        for but in range(nbuts):
            box.button(but).config(
                fg=theme.butFgColor,
                bg=theme.butBgColor,
                activeforeground=theme.butActiveFgColor,
                activebackground=theme.butActiveBgColor,
                highlightcolor=theme.butHighlightColor,
                highlightbackground=theme.butHighlightColor,
                padx=4,
                pady=4,
                font=theme.butFont
                )
            
    
    #@-body
    #@-node:1::__init__
    #@-others


#@-body
#@-node:14::class myDialog
#@+node:15::class myProgressBar
#@+body
"""
This code is based on a sample from the book:
"Python and Tkinter programming" by John Grayson.
Many many thanks to the author for saving me a couple
of boring hours.
"""

from Tkinter import *

class myProgressBar:
    def __init__(self, master=None, orientation="horizontal",
                 min=0, max=100, width=100, height=18,
                 doLabel=1, appearance="flat",
                 fillColor="blue", background="gray",
                 labelColor="yellow", labelFont="Verdana",
                 labelText="", labelFormat="%d%%",
                 value=50, bd=2):
        # preserve various values
        self.master=master
        self.orientation=orientation
        self.min=min
        self.max=max
        self.width=width
        self.height=height
        self.doLabel=doLabel
        self.fillColor=fillColor
        self.labelFont= labelFont
        self.labelColor=labelColor
        self.background=psst.theme.chatVoxLevelBgColor

        self.labelText=labelText
        self.labelFormat=labelFormat
        self.value=value
        self.frame=Frame(master, relief=appearance, bd=bd,
                         borderwidth=0,
                         highlightbackground=psst.theme.frmBgColor,
                         highlightcolor=psst.theme.frmBgColor,
                         )
        self.canvas=Canvas(self.frame, height=height, width=width, bd=0,
                           highlightthickness=0, background=self.background,
                           borderwidth=0,
                           highlightbackground=psst.theme.frmBgColor,
                           highlightcolor=psst.theme.frmBgColor,
                           )
        #print self.canvas.keys()
        self.scale=self.canvas.create_rectangle(0, 0, width, height,
                                                fill=fillColor)
        self.label=self.canvas.create_text(self.canvas.winfo_reqwidth()
/ 2,
                                           height / 2, text=labelText,
                                           anchor="c", fill=labelColor,
                                           font=self.labelFont)

        self.span = self.max - self.min

        self.update()
        self.canvas.pack(side='top', fill='x', expand='no')


    def updateProgress(self, newValue, newMax=None):
        if newMax:
            self.max = newMax
        self.value = newValue
        self.update()

    def update(self):

        # Trim the values to be between min and max
        value=self.value
        if value > self.max:
            value = self.max
        if value < self.min:
            value = self.min

        span = self.span
        red = min(255, (value-self.min)*510/span)
        green = min(255, (self.max - value)*510/span)
        #print "level=%d, red=%d, green=%d" % (value, red, green)

        self.fillColor = "#%02x%02x00" % (red, green)

        # Adjust the rectangle
        if self.orientation == "horizontal":
            self.canvas.coords(self.scale, 0, 0,
              float(value) / self.max * self.width, self.height)
        else:
            self.canvas.coords(self.scale, 0,
                               self.height - (float(value) / 
                                              self.max*self.height),
                               self.width, self.height)
        # Now update the colors
        self.canvas.itemconfig(self.scale, fill=self.fillColor)
        # And update the label
        if self.doLabel:
            self.canvas.itemconfig(self.label, fill=self.labelColor)
            if value:
                if value >= 0:
                    pvalue = int((float(value) / float(self.max)) * 
                                   100.0)
                else:
                    pvalue = 0
                self.canvas.itemconfig(self.label, text=self.labelFormat
                                         % pvalue)
            else:
                self.canvas.itemconfig(self.label, text='')
        else:
            pass
            #self.canvas.itemconfig(self.label, text=self.labelFormat %
            #                       self.labelText)
        self.canvas.update_idletasks()



#@-body
#@-node:15::class myProgressBar
#@+node:16::class myFrame
#@+body
class myFrame(Frame):
    def __init__(self, parent, **kwds):
        theme = psst.theme
        Frame.__init__(self,
                       parent,
                       bg=theme.frmBgColor,
                       highlightbackground=theme.frmBgColor,
                       highlightcolor=theme.frmBgColor,
                       borderwidth=0,
                       highlightthickness=0,
                       )
        

#@-body
#@-node:16::class myFrame
#@+node:17::class myPanedWindow
#@+body
class myPanedWidget(Pmw.PanedWidget):

    def __init__(self, parent, **kwds):
        theme = psst.theme
        handlesize = takeKey(kwds, 'handlesize', 0)

        Pmw.PanedWidget.__init__(self,
                                 parent,
                                 handlesize=handlesize,
                                 **kwds)

        self.component('hull').config(
            bg=theme.frmBgColor,
            highlightcolor=theme.frmBgColor,
            highlightbackground=theme.frmBgColor,
            )

    def add(self, name, **kw):
        pane = Pmw.PanedWidget.add(self, name, **kw)
        pane.config(
            bg=psst.theme.frmBgColor,
            highlightcolor=theme.frmBgColor,
            highlightbackground=theme.frmBgColor,
            )
        return pane

#@-body
#@-node:17::class myPanedWindow
#@+node:18::class myRadioSelect
#@+body
class myRadioSelect(Pmw.RadioSelect):
    
    def __init__(self, parent, **kwds):
        theme = psst.theme
        Pmw.RadioSelect.__init__(self, parent, **kwds)

        self.component('hull').config(
            bg=theme.frmBgColor,
            )
        try:
            self.component('frame').config(
                bg=theme.frmBgColor,
                )
        except:
            pass

        try:
            lab = self.component('label')
        except:
            return

        #print "configuring label for field"
        if lab:
            self.component('label').config(
                bg=theme.labBgColor,
                fg=theme.labFgColor,
                font=theme.labFont,
                #disabledbackground=theme.entryDisabledBgColor,
                disabledforeground=theme.entryDisabledFgColor,
                )

    def add(self, name, **kw):
        theme = psst.theme

        if sys.platform == 'win32':
            theme.radSelColor = theme.radBgColor

        but = Pmw.RadioSelect.add(self, name, **kw)
        but.config(
            fg=theme.radFgColor,
            bg=theme.radBgColor,
            font=theme.radFont,
            highlightcolor=theme.frmBgColor,
            highlightbackground=theme.frmBgColor,
            selectcolor=theme.radSelColor,
            activeforeground=theme.radActiveFgColor,
            activebackground=theme.radActiveBgColor,
            )
        #print "radiobutton font: %s" % but['font']
        #trace()
        return but


#@-body
#@-node:18::class myRadioSelect
#@+node:19::class myCanvas
#@+body
class myCanvas(Canvas):
    def __init__(self, parent, **kwds):
        theme = psst.theme
        Canvas.__init__(self, parent, **kwds)
        self.config(
            bg=theme.frmBgColor,
            highlightcolor=theme.frmBgColor,
            highlightbackground=theme.frmBgColor,
            )

#@-body
#@-node:19::class myCanvas
#@+node:20::class myGroup
#@+body
class myGroup(Pmw.Group):
    def __init__(self, parent, **kwds):
        Pmw.Group.__init__(self, parent, **kwds)

        theme = psst.theme

        self.interior().config(bg=theme.frmBgColor)
        self.component('hull').config(bg=theme.frmBgColor)
        self.component('ring').config(bg=theme.frmBgColor)
        try:
            self.component('tag').config(
                fg=theme.labFgColor,
                bg=theme.labBgColor,
                font=theme.labFont)
        except:
            pass

#@-body
#@-node:20::class myGroup
#@-node:1::Classes
#@+node:2::Functions
#@+node:1::myMessageBox
#@+body
def myMessageBox(parent, title, message, icontype, buttonlist, defbutton=0):
    """
    myMessageBox - create and display a modal message dialog on the fly.

    Arguments:
     - parent - parent window
     - title - text to put into window title bar
     - message - text to display inside dialog
     - icontype - 'information', 'warning' or 'error'
     - buttonlist - a list of button labels
     - defbutton - index of default button in list
    """
    if parent:
        try:
            parent.deiconify()
        except:
            pass
    dialog = Pmw.MessageDialog(
        parent,
        title=title,
        defaultbutton=0,
        buttons=buttonlist,
        buttonboxpos='s',
        iconpos='w',
        icon_bitmap=icontype,
        message_text=message)
    dialog.deiconify()
    dialog.show()
    result = dialog.activate()
    return result

#@-body
#@-node:1::myMessageBox
#@-node:2::Functions
#@-node:3::Customised Generic Widgets
#@+node:4::Dialogs
#@+node:1::class dlgHelpAbout
#@+body

#
# Define program dialogs
#

# About dialog
class dlgHelpAbout(Pmw.AboutDialog):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
        theme = psst.theme
        Pmw.aboutversion(psstVersion)
        Pmw.aboutcopyright('Copyright (C) David McNab 2003\n'
                           +'All rights reserved\n'
                           +'Released under the GNU General Public License')
        Pmw.aboutcontact('http://netforth.sf.net/psst')
        Pmw.AboutDialog.__init__(self, parent,
                                 applicationname = 'PSST')
        self.withdraw()
        self.component('dialogchildsite').config(bg=theme.frmBgColor)
        self.component('message').config(
            bg=theme.labBgColor,
            fg=theme.labFgColor,
            font=theme.labFont,
            )
    
        box = self.component('buttonbox')
        box.component('hull').config(
            bg=psst.theme.frmBgColor
            )
    
        nbuts = box.numbuttons()
        for but in range(nbuts):
            box.button(but).config(
                fg=theme.butFgColor,
                bg=theme.butBgColor,
                activeforeground=theme.butActiveFgColor,
                activebackground=theme.butActiveBgColor,
                highlightcolor=theme.butHighlightColor,
                highlightbackground=theme.butHighlightColor,
                padx=4,
                pady=4,
                font=theme.butFont
                )
    
    #@-body
    #@-node:1::__init__
    #@+node:2::activate
    #@+body
    def activate(self, **args):
        Pmw.AboutDialog.activate(self,
                                 geometry = 'centerscreenalways',
                                 **args)
    
    #@-body
    #@-node:2::activate
    #@-others


#@-body
#@-node:1::class dlgHelpAbout
#@+node:2::Theme
#@+node:1::function chooseTheme
#@+body
def chooseTheme():
    """
    Prompts user for a choice of theme

    Returns chosen theme name, or None
    """
    dlg = dlgTheme(None)
    return dlg.show()

#@-body
#@-node:1::function chooseTheme
#@+node:2::class dlgTheme
#@+body

# Passphrase dialog
class dlgTheme:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
        self.dlg = myDialog(parent,
                            buttons=('OK', 'Cancel'),
                            defaultbutton='OK',
                            title="Choose a Theme",
                            )
    
        # populate the dialog with some stuff
        frm = self.dlg.interior()
    
        self.labPrompt = myLabel(frm, text="Please select a theme", font='helvetica 14')
        self.labPrompt.pack(side=TOP, anchor=W)
    
        self.cmbTheme = myComboBox(frm,
                              )
        self.cmbTheme.pack(side=TOP)
        self.cmbTheme.setlist(Theme.getThemesList())
    
    #@-body
    #@-node:1::__init__
    #@+node:2::show
    #@+body
    def show(self, **args):
        res = self.dlg.activate(geometry = 'centerscreenalways',
                                **args)
        if res == 'OK':
            return self.cmbTheme.get()
        else:
            return None
    
    #@-body
    #@-node:2::show
    #@-others


#@-body
#@-node:2::class dlgTheme
#@-node:2::Theme
#@+node:3::Passphrase
#@+node:1::function demandpassphrase
#@+body
def demandpassphrase():
    """
    Prompts user for their passphrase, fail after 3 failures

    Returns True if correct passphrase given, False if not
    """
    attempts = 0
    maxattempts = 2
    prmt = "Please enter your current passphrase"
    while 1:
        result = getpassphrase("PSST Security",
                               prmt)
        if result == None:
            return False
        if result != psst.config.passphrase:
            if attempts >= maxattempts:
                myMessageBox(None,
                             "PSST Security Violation",
                             "Retry count exceeded",
                             'error',
                             ("OK",))
                return False
            else:
                # print "entered: '%s', correct: '%s'" % (result, psst.config.passphrase)
                prmt = "Sorry, wrong passphrase. Please try again"
                attempts += 1
                continue
        else:
            return True

#@-body
#@-node:1::function demandpassphrase
#@+node:2::function getpassphrase
#@+body
def getpassphrase(title, prompt, **kwds):
    dlg = dlgPassphrase(None)
    return dlg.show(title, prompt, **kwds)

#@-body
#@-node:2::function getpassphrase
#@+node:3::class dlgPassphrase
#@+body

# Passphrase dialog
class dlgPassphrase:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
        self.dlg = myDialog(parent,
                            buttons=('OK', 'Cancel'),
                            defaultbutton='OK',
                            title="Enter your passphrase",
                            #command=self.execute,
                            )
        self.dlg.withdraw()
    
        # populate the dialog with some stuff
        frm = self.dlg.interior()
    
        self.labPrompt = myLabel(frm, text="", font='helvetica 12')
        self.labPrompt.pack(side=TOP, anchor=W)
    
        fld = self.fldPass = myEntry(frm,
                                     width=30,
                                     )
        fld.component('entry')['show'] = '*'
        fld.pack(side=TOP)
    
    #@-body
    #@-node:1::__init__
    #@+node:2::show
    #@+body
    def show(self, title, prompt, **args):
        self.dlg['title'] = title
        self.labPrompt['text'] = prompt
        self.fldPass.setvalue('')
        self.fldPass.component('entry').focus_set()
        res = self.dlg.activate(geometry = 'centerscreenalways',
                                **args)
        if res == 'OK':
            return self.fldPass.getvalue()
        else:
            return None
    
    #@-body
    #@-node:2::show
    #@-others


#@-body
#@-node:3::class dlgPassphrase
#@-node:3::Passphrase
#@+node:4::class dlgPeer
#@+body

# Peer dialog
class dlgPeer(myDialog):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
    
        self.buildWindow(parent)
        self.bindEvents()
    
    #@-body
    #@-node:1::__init__
    #@+node:2::buildWindow
    #@+body
    def buildWindow(self, parent):
    
        myDialog.__init__(self, parent,
                          buttons = ('OK', 'Cancel'),
                          defaultbutton = 'OK',
                          title = 'PSST Peer',
                          command = self.execute)
        self.withdraw()
    
        # populate the dialog with some stuff
        frm = self.interior()
        w = self.statTitle = myLabel(frm,
                                   text="Peer Dialog",
                                   font="Helvetica 16 bold",
                                   )
        w.pack(side=TOP)
    
        w = myFrame(frm)
        w.pack(side=TOP)
        myLabel(w, text="Nickname:").pack(side=LEFT)
        w1 = self.fldNick = myEntry(w, width=16)
        w1.pack(side=LEFT)
    
        g = myGroup(frm, tag_text="Peer connection details")
        g.pack(side=TOP,
               fill=BOTH,
               expand=1,
               )
        g = g.interior()
        g0 = myFrame(g)
        g0.pack(side=TOP)
    
        g00 = myFrame(g0)
        g00.pack(side=LEFT)
    
        myLabel(g00, text="Hostname/IP").pack(side=TOP)
        h = self.fldDefaultHost = myEntry(g00, width=40)
        h.pack(side=TOP)
        g01 = myFrame(g0)
        g01.pack(side=LEFT)
        myLabel(g01, text="Port").pack(side=TOP)
        p = self.fldDefaultPort = myEntry(g01, width=7)
        p.pack(side=TOP)
    
        c = self.cmbDefaultHost = myComboBox(g)
        c.pack(side=TOP)
        #trace()
    
        g = myGroup(
            frm,
            tag_text="How much do you trust this person?")
        g.pack(side=TOP,
               fill=BOTH,
               expand=1,
               )
        g = g.interior()
    
        p = myPanedWidget(g,
                          orient='horizontal',
                          hull_borderwidth=0,
                          separatorthickness=1,
                          separatorrelief='raised',
                          handlesize=0,
                          )
        p.pack(expand=1, fill=BOTH)
    
        g0 = p.add("l", size=.5, min=.5,max=.5)
        g0.pack(side=LEFT,expand=1, fill=BOTH)
    
        self.chkAutoAccept_v = IntVar()
        c = self.chkAutoAccept = myCheckbutton(
            g0,
            text="Auto-accept connections",
            width=20,
            var=self.chkAutoAccept_v
            )
        c.pack(side=TOP)
    
        self.chkAllowFileAccess_v = IntVar()
        c = self.chkAllowFileAccess = myCheckbutton(
            g0,
            text="Grant access to shared files",
            width=20,
            var=self.chkAllowFileAccess_v)
        c.pack(side=TOP)
        c['state'] = DISABLED
    
        g0 = p.add("r")
        g0.pack(side=LEFT,expand=1, fill=BOTH)
    
        self.chkAllowVoice_v = IntVar()
        c = self.chkAllowVoice = myCheckbutton(
            g0,
            text="Allow Voice Chat",
            width=40,
            var=self.chkAllowVoice_v)
        c.pack(side=TOP)
    
        self.chkAllowWebProxy_v = IntVar()
        c = self.chkAllowWebProxy = myCheckbutton(
            g0,
            text="Grant Access to Web Proxy",
            width=40,
            var=self.chkAllowWebProxy_v)
        c.pack(side=TOP)
        c['state'] = DISABLED
    
    #@-body
    #@-node:2::buildWindow
    #@+node:3::bindEvents
    #@+body
    def bindEvents(self):
        """
        Create the event bindings
        """
        self.cmbDefaultHost.configure(selectioncommand=self.on_cmbDefaultHost)
    
    #@-body
    #@-node:3::bindEvents
    #@+node:4::activate
    #@+body
    def activate(self, nick, connecting, **args):
    
        self.connecting = connecting
        self.fldNick.setvalue(nick)
    
        d = psst.config.peers[nick]
        key = d['key']
    
        self.fldDefaultHost.setvalue(d.get('host', ''))
        self.fldDefaultPort.setvalue(str(d.get('port', defaultPort)))
    
        #self.cmbDefaultHost.items = d.get('prevHosts', [])
        try:
            self.cmbDefaultHost.setlist(d.get('prevHosts'))
        except:
            pass
    
        self.chkAutoAccept_v.set(d.get('autoAccept', 1))
        self.chkAllowVoice_v.set(d.get('allowVoice', 1))
        self.chkAllowFileAccess_v.set(d.get('allowFileAccess', 0))
        self.chkAllowWebProxy_v.set(d.get('allowWebProxy', 0))
    
        if connecting:
            self['title'] = "Connecting..."
            self.statTitle.config(
                text=("Connecting to peer '%s'" % nick),
                )
            self.fldNick.component('entry').config(state=DISABLED)
            #self.fldNick.component('entry').config(state=NORMAL)
        else:
            self['title'] = "Edit peer details"
            self.statTitle.config(
                text=("Editing configuration for peer '%s'" % nick),
                )
            self.fldNick.component('entry').config(state=NORMAL)
    
        result = Pmw.Dialog.activate(self, geometry='centerscreenalways', **args)
        #print "activate: result=", result
    
        if result == 'OK':
            #print "clicked ok"
            newnick = self.fldNick.getvalue()
            d = psst.config.peers[newnick] = {}
            d['host'] = self.fldDefaultHost.getvalue()
            d['port'] = int(self.fldDefaultPort.getvalue())
            d['autoAccept'] = self.chkAutoAccept_v.get()
            d['allowVoice'] = self.chkAllowVoice_v.get()
            d['allowFileAccess'] = self.chkAllowFileAccess_v.get()
            d['allowWebProxy'] = self.chkAllowWebProxy_v.get()
            d['key'] = key
            d['prevHosts'] = list(
                self.cmbDefaultHost.component('scrolledlist').component('listbox').get(0, END))
    
            # save
            #trace()
            if not d.has_key('prevHosts'):
                d['prevHosts'] = []
            newhost = "%s:%s" % (d['host'], d['port'])
            try:
                d['prevHosts'].index(newhost)
            except:
                d['prevHosts'].insert(0, newhost)
            if len(d['prevHosts']) > 16:
                d['prevHosts'].pop()
    
            # delete old peer if renamed
            if newnick != nick:
                del psst.config.peers[nick]
    
            psst.config.save()
    
            if connecting:
                gConnections[newnick] = {}
                gConnections[newnick].update(d)
                gWinMain.showPeerConnected(newnick)
                thread.start_new_thread(threadConnect, (newnick, d['host'], d['port']))
        else:
            #print "clicked cancel"
            pass
    
        return result
    
    #@-body
    #@-node:4::activate
    #@+node:5::execute
    #@+body
    def execute(self, result):
        #print"dlgPeer: clicked on %s" % result
        self.deactivate(result)
        return result
    
    #@-body
    #@-node:5::execute
    #@+node:6::on_cmbDefaultHost()
    #@+body
    def on_cmbDefaultHost(self, item):
        #trace()
        #print"dlgPeer.on_cmbDefaultHost_select: choosing prior address"
        #host, port = self.cmbDefaultHost.component('entryfield').getvalue().split(":")
        host, port = item.split(":")
        self.fldDefaultHost.setvalue(host)
        self.fldDefaultPort.setvalue(port)
    
    #@-body
    #@-node:6::on_cmbDefaultHost()
    #@-others


#@-body
#@-node:4::class dlgPeer
#@+node:5::class dlgSettings
#@+body
class dlgSettings(myDialog):

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
        myDialog.__init__(self, parent,
                          buttons = ('OK', 'Cancel'),
                          defaultbutton = 'OK',
                          title = 'PSST Settings',
                          command = self.execute)
        self.withdraw()
    
        # populate the dialog with some stuff
        frm = self.interior()
    
        self.radPermissions = 0
    
        #trace()
        self.layout = tCol(
            tW(myLabel, '',
               text="PSST Settings", font="helvetica 16 bold", pack=[0,0,CENTER]),
            tRow(tCol(tW(myLabel, '',
                         text="My Nickname", pack=[0,0,E]),
                      tW(Canvas, '', width=10, height=3),
                      tW(myLabel, '',
                         text="Keys Directory", pack=[0,0,E]),
                      tW(Canvas, '', width=10, height=3),
                      tW(myLabel, '',
                         text="Listen on Port", pack=[0,0,E])),
                 tCol(tW(myEntry, 'nick'),
                      tRow(tW(myEntry, 'keysdir', width=50),
                           tW(myButton, 'butbrowse',
                              text="Browse", width=6)),
                      tW(myEntry, 'listenport',
                         width=6,
                         pack=[NONE,0,W]))),
            tW(myLabel, '', text='Incoming Connections', pack=[0,1,CENTER]),
            tRow(tW(Canvas, '', width=20,height=2),
                 tCol(tGroup(tW(Canvas, '',
                                width=10,height=8),
                             tRadio('permissions', 'down',
                                    ['Accept Automatically',
                                     'Ask My Permission',
                                     'Always Block'],
                                    1,
                                    command=self.on_permissions,
                                    font="helvetica 10"),
                             tag_text="Permissions")),
                 tW(Canvas, '', width=20,height=2),
                 tCol(tRow(tW(myCheckbutton, 'chkPlaySound',
                              text="Play Sound File"),
                           tW(myButton, 'butBrowse', text="Browse"),
                           tW(myButton, 'butPlay', text="Play")),
                      tRow(tW(myEntry, 'fldSndFile',
                              width=40))
                      ),
                 )
            )
    
        self.layout.tBuild(frm)
        #print self.layout.wi
        #self.layout.wid('rad0').select()
    
    #@-body
    #@-node:1::__init__
    #@+node:2::activate
    #@+body
    def activate(self, **args):
        Pmw.Dialog.activate(self, geometry='centerscreenalways', **args)
    
    #@-body
    #@-node:2::activate
    #@+node:3::execute
    #@+body
    def execute(self, result):
        #print"dlgSettings: clicked on %s" % result
        self.deactivate(result)
    
    #@-body
    #@-node:3::execute
    #@+node:4::on_permissions
    #@+body
    def on_permissions(self, event=None):
        try:
            #print "on_permissions: event=%s" % event
            perm = self.layout.wid('permissions')
            self.radPermissions = perm.index(event)
            # if self.layout.wid('rad0').
            # trace()
            # print "permissions=%s" % self.radPermissions
            # %d" % self.layout.wid('permissions')
            print "permissions=%d" % self.radPermissions
        except:
            print "exception in on_permissions"
            pass
    
    #@-body
    #@-node:4::on_permissions
    #@-others


#@-body
#@-node:5::class dlgSettings
#@+node:6::class dlgPassphrase999
#@+body
class dlgPassphrase999:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, parent):
        # Create the dialog to prompt for the passphrase
        self.dialog = Pmw.PromptDialog(
            parent,
            title = 'PSST Security',
            label_text = 'Please enter your passphrase:',
            entryfield_labelpos = 'nw',
            entry_show = '*',
            defaultbutton = 0,
            buttons = ('OK', 'Cancel'),
            command = self.execute)
        self.dialog.withdraw()
    
    #@-body
    #@-node:1::__init__
    #@+node:2::activate
    #@+body
    def show(self, **args):
        res = self.dialog.activate(self, geometry='centerscreenalways', **args)
        #print"activate: res=", res
    
    #@-body
    #@-node:2::activate
    #@+node:3::execute
    #@+body
    def execute(self, result):
        if result is None or result == 'Cancel':
            #print'Password prompt cancelled'
            passphrase = None
        else:
            result = self.confirm.activate()
            if result == 'OK':
                passphrase = self.dialog.get()
                #print'Password entered ' + passphrase
        self.dialog.deactivate(result)
        return passphrase
    
    #@-body
    #@-node:3::execute
    #@-others


#@-body
#@-node:6::class dlgPassphrase999
#@-node:4::Dialogs
#@+node:5::Wizard
#@+node:1::class wizSetup
#@+body
class wizSetup:

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, master, **kwds):
    
        self.dlg = self.buildWizard(master, **kwds)
        self.setDefaults()
        self.getFromConfig()
        self.values = None
    
    #@-body
    #@-node:1::__init__
    #@+node:2::setDefaults
    #@+body
    def setDefaults(self):
        self.valKey = None
    
    #@-body
    #@-node:2::setDefaults
    #@+node:3::buildWizard
    #@+body
    def buildWizard(self, master, **kwds):
    
        dlg = myDialog(master,
                       buttons = ('Prev', 'Next', 'Cancel'),
                       defaultbutton = 'Next',
                       title = 'PSST Setup wizard',
                       command = self.on_but)
        dlg.withdraw()
        dlgWid = self.dlgWid = dlg.interior()
        dlg.component('hull')['width'] = 100
    
        # stick a listbox on the left
        self.lstPages = myListBox(dlgWid,
                                  items=(),
                                  selectioncommand=self.on_lstSelect,
                                  )
        self.lstPages.pack(side=LEFT, anchor=NW)
        self.lstPages.component('listbox').config(width=10)
    
        # get button refs
        bbox = self.butBox = dlg.component('buttonbox')
        try:
            bbox.config(padx=60)
        except:
            #print"bbox config failed"
            pass
        #trace()
        self.butPrev = bbox.button("Prev")
        self.butNext = bbox.button("Next")
        self.butCancel = bbox.button("Cancel")
        self.butPrev['width'] = 10
    
        # Stick in a Notebook widget
        book = self.book = myNotebook(dlgWid,
                                      tabpos=None,
                                      raisecommand=self.on_page,
                                      borderwidth=0
                                      )
        h = book.component('hull')
        #print h.keys()
        h.config(
            highlightbackground=psst.theme.frmBgColor,
            highlightcolor=psst.theme.frmBgColor,
            relief='flat',
            )
    
        book.pack(fill=BOTH, expand=1, padx=10, pady=10)
        self.pages = {}
        self.pageList = []
    
        # And build its pages
    
        # Page - start
        page = self.addPage("Start")
    
        #trace()
    
        #book.tab("Start").focus_set()
        #book.tab(self.pages["Start"]).focus_set()
    
        lab = myLabel(page,
                      text="Welcome to the PSST Configuration Wizard.\n\n"
                           +"Please follow this wizard to get things set up\n\n\n"
                           +"Click 'Next' to continue",
                      )
        lab.pack(fill=BOTH, expand=1, padx=10, pady=10)
    
        # Page - encryption
        page = self.addPage("Encryption")
    
        lab = myLabel(page,
                      text="This program uses RSA encryption for public keys,\n"
                          +"and 256-bit Blowfish (CFB mode) for session cipher.\n\n"
                          +"(For your added security, separate session)\n"
                          +"keys are used for sending and receiving)\n\n"
                          +"Please select the desired strength\n"
                          +"for your public/private keys",
                      height=12,
                      )
        lab.pack()
    
        frm = myFrame(page)
        frm.pack(side=TOP, expand=1, fill=BOTH)
    
        rad = self.radKeyLen = myRadioSelect(frm,
                                             pady=0,
                                             orient=VERTICAL,
                                             buttontype='radiobutton',
                                             command=self.on_radKeySize,
                                             )
        rad.pack(side=TOP)
    
        opts = self.pubKeyOpts = ["1024 bits (personal grade)",
                                  "2048 bits (commercial grade)",
                                  "3072 bits (military grade)",
                                  "4096 bits (paranoia grade)",
                                  ]
        self.pubKeyIndexes = {1024:0, 2048:1, 3072:2, 4096:3}
    
        for opt in opts:
            comp = rad.add(opt)
        rad.invoke(opts[1])
    
        # Page - Random number generation
        page = self.addPage("Entropy")
        lab = myLabel(page,
                      text="In order for the encryption to be secure, I'll need\n"
                          +"you to generate some random data. (Machine-generated\n"
                          +"random data is not good enough, because an attacker\n"
                          +"can easily reconstruct it. Only human-generated\n"
                          +"randomness can provide real security.)\n\n"
                          +"So what I need you to do now is move your mouse around\n"
                          +"randomly inside this window until the progress bar\n"
                          +"below fills up to 100%",
                      height=12)
        lab.pack(side=TOP)
    
        self.guaEntropy = myProgressBar(page,
                                        width=200,
                                        height=40,
                                        doLabel=1,
                                        value=0,
                                        )
        self.guaEntropy.frame.pack(side=TOP)
        self.entropy = 0
        self.entropyMax = 512
    
        self.labEntropy = myLabel(page, text="", height=4)
        self.labEntropy.pack(side=TOP)
        self.txtEntropy = ""
    
        # bind all these widgets to mouse motion handler
        for wid in [page, lab, self.guaEntropy.canvas, self.labEntropy]:
            wid.bind("<Motion>", self.on_moveMouse)
        # create last x and y mouse positions - we're measuring differential motion
        self.lastX = self.lastY = 0
    
        # Page - Key generation
        page = self.addPage("Keys")
        lab = myLabel(page,
                      text="Now, we need to generate your public and private keys.\n\n"
                          +"Click 'Generate Keys' to continue.",
                      height=6)
        lab.pack(side=TOP)
        but = self.butGenerateKeys = myButton(page,
                       command=self.on_butGenerateKeys,
                       text="Generate my Keys"
                       )
        but.pack(side=TOP)
    
        self.statKeyGen = myLabel(page,
                                  text="",
                                  height=2)
        self.statKeyGen.pack(side=TOP)
        self.statKeyGen1 = myLabel(page,
                                  text="",
                                  height=1)
        self.statKeyGen1.pack(side=TOP)
    
        s = myLabel(page,
                    text="NOTE - if you have chosen a larger key size, and/or\n"
                        +"if you have a slow machine, this program may appear\n"
                        +"to freeze while generating keys. If this happens,\n"
                        +"please be patient - it wlll get there eventually!",
                    height=6)
        s.pack(side=TOP)
    
        # Page - Passphrase
        page = self.addPage("Passphrase")
        lab = myLabel(page,
                      text="PSST stores all its data - your public/private keys,\n"
                          +"public keys of your peers, plus program settings,\n"
                          +"in a single file called psstConfig.dat.\n\n"
                          +"By default, this file is not encrypted. But if you're\n"
                          +"concerned that someone may get physical (or remote)\n"
                          +"access to your PC, it might be wise to encrypt this\n"
                          +"file with a passphrase.\n\n"
                          +"If you choose a passphrase, please be sure to choose\n"
                          +"a string that can't be easily guessed or hacked.",
                      height=13)
        lab.pack(side=TOP)
    
        fld = self.fldPassphrase = myEntry(page,
                                           width=30,
                                           labelpos=W,
                                           label_text="Passphrase")
        fld.component('entry')['show'] = '*'
        fld.pack(side=TOP)
    
        fld = self.fldPassphrase1 = myEntry(page,
                                           width=30,
                                           labelpos=W,
                                           label_text="  and again:")
        fld.component('entry')['show'] = '*'
        fld.pack(side=TOP)
    
        lab = myLabel(page,
                      text="Don't forget your passphrase. If you forget\n"
                          +"it, PSST won't be able to recover it for you\n",
                      height=3,
                      )
        lab.pack(side=TOP)
    
        # Page - Nick
        page = self.addPage("Your nick")
        lab = myLabel(page,
                      text="Please choose a 'nickname' to identify\n"
                          +"yourself to others you're chatting with.\n\n"
                          +"Please choose a name up to 16 characters,\n"
                          +"consisting only of letters and/or, numbers",
                      height=15)
        lab.pack(side=TOP)
    
        fld = self.fldNick = myEntry(page,
                                     width=25,
                                     labelpos=W,
                                     label_text="Your nick:",
                                     validate={'validator':'alphanumeric',
                                               'max':16},
                                     )
        fld.pack(side=TOP)
    
        # Page - Port
        page = self.addPage("Port")
        lab = myLabel(page,
                      text="If you're not behind a firewall, or have\n"
                          +"control of your firewall, you can accept\n"
                          +"incoming TCP connections. Please select a\n"
                          +"port to listen on, or accept the default\n",
                      height=15)
        lab.pack(side=TOP)
    
        fld = self.fldPort = myEntry(page,
                                     width=6,
                                     labelpos=W,
                                     label_text="Listen on Port:",
                                     validate={'validator':'numeric',
                                               'min':1,
                                               'max':65535,
                                               'minstrict':False},
                                     value="44154",
                                     )
        fld.pack(side=TOP)
    
        # Page - Permissions
        page = self.addPage("Permissions")
        lab = myLabel(page,
                      text="Please set your default permissions\n",
                      height=4)
        lab.pack(side=TOP)
    
        rad = self.radPermIncoming = myRadioSelect(
            page,
            pady=0,
            orient=VERTICAL,
            buttontype='radiobutton',
            command=self.on_radIncomingConn,
            labelpos="n",
            label_text="Incoming Peer Connections"
            )
        rad.pack(side=TOP)
    
        opts = self.connOpts = ["Accept Automatically",
                                "Ask My Permission",
                                "Always Reject",
                                ]
        for opt in opts:
            comp = rad.add(opt)
        rad.invoke(0)
        
    
        # Page - Audio
        page = self.addPage("Audio")
        lab = myLabel(page,
                      text="You can test your audio setup here\n",
                      height=4)
        lab.pack(side=TOP)
    
        frm = myFrame(page)
        frm.pack(side=TOP)
    
        but = self.butAudioOutStart = myButton(frm,
                                               text="Start",
                                               command=self.on_butAudioOutStart)
        but.pack(side=LEFT)
    
        but = self.butAudioOutStop = myButton(frm,
                                              text="Stop",
                                              command=self.on_butAudioOutStop,
                                              state=DISABLED)
        but.pack(side=LEFT)
    
        lab = myLabel(page,
                      text="Output Test - Click 'Start' to loop a sample",
                      height=4)
        lab.pack(side=TOP)
    
        frm = myFrame(page)
        frm.pack(side=TOP)
    
        but = self.butAudioInStart = myButton(frm,
                                              text="Start",
                                              command=self.on_butAudioInStart,
                                              )
        but.pack(side=LEFT)
    
        but = self.butAudioInStop = myButton(frm,
                                             text="Stop",
                                             command=self.on_butAudioInStop,
                                             state=DISABLED
                                             )
        but.pack(side=LEFT)
    
        lab = myLabel(page,
                      text="Input Test - Click 'Start' to record/playback\n"
                          +"between soundcard input/output in 2 second bursts\n",
                      height=4)
        lab.pack(side=TOP)
    
        lab = self.statAudioTestStatus = myLabel(page,
                                                 text="",
                                                 height=2)
        lab.pack(side=TOP)
    
    
        # Page - Finish
        page = self.addPage("Finish")
    
        cnv = myCanvas(page, height=30)
        cnv.pack(side=TOP)
    
        lab = myLabel(page,
                      font="helvetica 16 bold",
                      text="Finishing PSST Configuration")
        lab.pack()
    
        cnv = myCanvas(page, height=10)
        cnv.pack(side=TOP)
    
        lab = myLabel(page,
                      text="Please check your settings, and click\n"
                       +"'Finish' if you are happy with them",
                      height=4)
        lab.pack()
    
        #frmStart = self.baseFrame(pageStart,
        #                          self.on_butPrev,
        #                          self.on_butNext,
        #                          self.on_butFinish,
        #                          self.on_butCancel)
        #frmStart.pack(fill=BOTH, expand=1)
    
        book.setnaturalsize()
    
        self.lstPages.setlist(self.pageList)
        self.lstPages.setvalue("Start")
    
        return dlg
    
        # old leftover stuff
        #
        #
        book = self.book = myNotebook(dlg, **kwds)
        book.pack(fill = 'both', expand = 1, padx = 10, pady = 10)
    
        # Add the "Appearance" page to the notebook.
        page = self.addPage('Appearance')
        book.tab('Appearance').focus_set()
    
        # Create the "Toolbar" contents of the page.
        group = myGroup(page, tag_text = 'Toolbar')
        group.pack(fill = 'both', expand = 1, padx = 10, pady = 10)
        b1 = Tkinter.Checkbutton(group.interior(), text = 'Show toolbar')
        b1.grid(row = 0, column = 0)
        b2 = Tkinter.Checkbutton(group.interior(), text = 'Toolbar tips')
        b2.grid(row = 0, column = 1)
    
        # Create the "Startup" contents of the page.
        group = myGroup(page, tag_text = 'Startup')
        group.pack(fill = 'both', expand = 1, padx = 10, pady = 10)
        home = myEntryField(group.interior(), labelpos = 'w',
                              label_text = 'Home page location:')
        home.pack(fill = 'x', padx = 20, pady = 10)
        
        # Add two more empty pages.
        page = self.addPage('Helpers')
        page = self.addPage('Images')
    
        book.setnaturalsize()
    
        #book.withdraw()
    
    #@-body
    #@-node:3::buildWizard
    #@+node:4::addPage
    #@+body
    def addPage(self, name):
        page = self.book.add(name)
        page.config(
            highlightbackground=psst.theme.frmBgColor,
            highlightcolor=psst.theme.frmBgColor,
            relief='flat',
            )
        #print page.__class__
        #print page.keys()
    
        lab = myLabel(page,
                      font="Helvetica 16 bold",
                      text=name)
        lab.pack(side=TOP)
    
        self.pages[name] = page
        self.pageList.append(name)
    
        return page
    
    #@-body
    #@-node:4::addPage
    #@+node:5::validate
    #@+body
    def validate(self):
        """
        Checks through all data. If something is missing, puts up
        a message box and takes the user to the required page
    
        Returns a dict of values if everything is valid, or False if not
        """
    
        key = self.valKey
        publen = self.valKeySize
        passphrase = self.fldPassphrase.getvalue()
        passphrase1 = self.fldPassphrase1.getvalue()
        nick = self.fldNick.getvalue()
        try:
            port = int(self.fldPort.getvalue())
        except:
            port = 0
    
        values = {'key':key,
                  'publen':publen,
                  'passphrase':passphrase,
                  'nick':nick,
                  'port':port,
                  'incoming':self.valIncomingConn,
                  }
    
        if not key:
            if self.entropy < self.entropyMax:
                self.complain("Please complete the entropy generation",
                              "Entropy")
            else:
                self.complain("You need to generate your public/private keys",
                              "Keys")
            return False
    
        if passphrase != passphrase1:
            self.complain("Your passphrases don't match", "Passphrase")
            return False
    
        if passphrase == '':
            if myMessageBox(None,
                            "PSST Security - nonexistent passphrase alert",
                            "You are about to save your config file without a passphrase.\n"
                            +"Are you really sure you want to do this?",
                            'question',
                            ("Yes","No")) == 'Yes':
                myMessageBox(None,
                             "PSST Security Warning",
                             "Don't say I haven't warned you!",
                             "warning",
                             ("OK",))
            else:
                self.complain("Please enter a passphrase", "Passphrase")
                return False
    
        elif len(passphrase) < 8:
            if myMessageBox(None,
                            "PSST Security - weak passphrase alert",
                            ("Your passphrase is very weak - only %d characters\n" \
                              % len(passphrase))
                            +"It can be very easily cracked if an\n"
                            +"attacker gets access to your PC\n"
                            +"Are you really sure you want to do this?",
                            'question',
                            ("Yes","No")) != 'Yes':
                self.complain("Please enter a longer passphrase", "Passphrase")
                return False
    
        if nick == '':
            self.complain("You must enter a nick", "Your nick")
            return False
        if port < 1 or port > 65535:
            self.complain("You must choose a port between 1024 and 65535", "Port")
            return False
    
        # everything's fine
        return values
    
    
    #@-body
    #@-node:5::validate
    #@+node:6::putToConfig
    #@+body
    def putToConfig(self, val):
        """
        Uplift field values from wizard, and store into the global config record
        """
        #printval
        psst.config.pubKeyCipher = "RSA"
        psst.config.pubKeyLen = val['publen']
        psst.config.sessKeyCipher = "Blowfish"
        psst.config.sessKeyLen = 256
        psst.config.passphrase = val['passphrase']
        psst.config.myNick = val['nick']
        psst.config.listenPort = val['port']
        psst.config.connIncoming = val['incoming']
    
        psst.config.allowWebProxy = False
        psst.config.allowFileSharing = False
        psst.config.fileShareDir = ""
    
        psst.config.myKey = val['key']
        psst.config.valid = 1
    
        psst.config.save()
        #print"wizSetup.putToConfig: saved config"
    
    #@-body
    #@-node:6::putToConfig
    #@+node:7::getFromConfig
    #@+body
    def getFromConfig(self):
        """
        Take values from config, if any, and write into wizard's widgets
        """
    
        if psst.config.valid:
            self.valKey = psst.config.myKey
            #trace()
            try:
                self.radKeyLen.invoke(psst.config.pubKeyLen)
            except:
                self.radKeyLen.invoke(self.pubKeyIndexes[psst.config.pubKeyLen])
            self.fldPassphrase.setvalue(psst.config.passphrase)
            self.fldPassphrase1.setvalue(psst.config.passphrase)
            self.fldNick.setvalue(psst.config.myNick)
            self.fldPort.setvalue("%s" % psst.config.listenPort)
            self.radPermIncoming.invoke(psst.config.connIncoming)
    
    #@-body
    #@-node:7::getFromConfig
    #@+node:8::complain
    #@+body
    def complain(self, message, page=None):
        """
        puts up a message box complaining that user has
        neglected something. Then, switches to the offending page
        """
        myMessageBox(self.dlg.interior(),
                     "PSST - Invalid Setting",
                     message,
                     'warning',
                     ('OK',))
        if page:
            #print"complain: going to page", page
            self.book.selectpage(page)
    
    #@-body
    #@-node:8::complain
    #@+node:9::on_but
    #@+body
    def on_but(self, event=None):
        #trace()
        #print "on_but: clicked", event
        page = self.book.getcurselection()
        #print "current page is", page
        if event==None or event=='Cancel':
            self.dlg.deactivate()
    
        if page == 'Finish' and event == 'Next':
            self.values = self.validate()
            if self.values:
                self.dlg.deactivate()
            else:
                return
    
        if event == 'Next':
            self.book.nextpage()
        elif event == 'Prev':
            self.book.previouspage()
    
    #@-body
    #@-node:9::on_but
    #@+node:10::on_page
    #@+body
    def on_page(self, page):
        """
        Called when a new page is selected
        """
        #print "on_page: page=", page
    
        if page == 'Start':
            self.butPrev['state'] = DISABLED
            self.butNext['text'] = "Next"
        elif page == 'Finish':
            self.butPrev['state'] = NORMAL
            self.butNext['text'] = "Finish"
        else:
            self.butPrev['state'] = NORMAL
            self.butNext['text'] = "Next"
    
        #print self.lstPages.get()
        if len(self.pageList) > 0:
            self.lstPages.setvalue(page)
    
    #@-body
    #@-node:10::on_page
    #@+node:11::on_lstSelect
    #@+body
    def on_lstSelect(self):
        """
        Callback triggered when user clicks on a page list item
    
        Switches to selected page
        """
    
        self.book.selectpage(self.lstPages.getvalue()[0])
        self.on_turnPage()
    
    #@-body
    #@-node:11::on_lstSelect
    #@+node:12::on_butPrev
    #@+body
    def on_butPrev(self, event=None):
        #print "clicked prev"
        self.on_turnPage()
    
    #@-body
    #@-node:12::on_butPrev
    #@+node:13::on_butNext
    #@+body
    def on_butNext(self, event=None):
        #print "clicked next"
        self.on_turnPage()
    
    #@-body
    #@-node:13::on_butNext
    #@+node:14::on_butFinish
    #@+body
    def on_butFinish(self, event=None):
        #print "clicked finish"
        pass
    
    #@-body
    #@-node:14::on_butFinish
    #@+node:15::on_butCancel
    #@+body
    def on_butCancel(self, event=None):
        #print "clicked cancel"
        pass
    
    #@-body
    #@-node:15::on_butCancel
    #@+node:16::on_turnPage
    #@+body
    def on_turnPage(self):
        pageName = self.book.getcurselection()
        print "Switched to page '%s'" % pageName
        if pageName == 'Entropy' and self.entropy < self.entropyMax:
            if self.valKey:
                self.entropy = self.entropyMax
                self.labEntropy['text'] = "No need to generate entropy at this stage.\n" \
                                          +"Please click 'Next' to continue"
                self.guaEntropy.updateProgress(100)
            else:
                # Enter entropy generation phase
                print "Need entropy"
                self.freezePage()
    
    #@-body
    #@-node:16::on_turnPage
    #@+node:17::on_moveMouse
    #@+body
    def on_moveMouse(self, event=None):
        if self.entropy < self.entropyMax:
            x, y = event.x_root, event.y_root
            dx = (self.lastX - x) % 256
            dy = (self.lastY - y) % 256
            
            byte = dx * 256 + dy
            char = "%04x" % byte
            self.txtEntropy += "%d" % (byte % 2)
            self.txtEntropy = self.txtEntropy[-32:]
    
            self.lastX, self.lastY = x, y
    
            SSLCrypto.randomseed(char)
            self.entropy += 1
            self.guaEntropy.updateProgress(self.entropy * 100 / self.entropyMax)
            self.labEntropy['text'] = self.txtEntropy + "\n" + char
            time.sleep(0.05)
    
            if self.entropy >= self.entropyMax:
                # entropy generation done
                self.unfreezePage()
                self.labEntropy['text'] = ("\n\nEntropy generation complete!\n"
                                           + "Please click 'Next' to continue")
    
    #@-body
    #@-node:17::on_moveMouse
    #@+node:18::on_butGenerateKeys
    #@+body
    def on_butGenerateKeys(self):
        #print "generate keys"
    
        if self.entropy < self.entropyMax:
            self.complain("Please complete the entropy generation",
                          "Entropy")
            return
    
        if self.valKey:
            if myMessageBox(None,
                            "PSST Security Warning - Replacing Public Keys",
                            "You are about to destroy your existing public/private keys.\n"
                            "If you do this, you will have to re-export your public key\n"
                            "and issue it to all of your peers.\n\n"
                            "This is a wise thing to do from time to time, since it will\n"
                            "permanently destroy an attacker's ability to decrypt any\n"
                            "prior communications, even WITH your cooperation. But if\n"
                            "you have a large number of peers, and/or if you don't have\n"
                            "trustworthy ways of getting your public key to them intact,\n"
                            "this can prove very inconvenient.\n\n"
                            +"Are you really sure you want to destroy and replace your keys?",
                            'question',
                            ("Yes","No")) != 'Yes':
                return
    
        self.freezePage()
        self.butGenerateKeys['state'] = DISABLED
    
        self.statKeyGen['text'] = "Please wait while I generate your keys..."
        self.statKeyGen1['text'] = ""
        self.statKeyGen1['font'] = "courier 10 bold"
        self.statKeyGen1['fg'] = "#008000"
    
        self.keyProgress = 0
        self.threadrunning = True
        self.butGenerateKeys.after(10, self.tickGenerateKeys)
        thread.start_new_thread(self.threadGenerateKeys, ())
    
    
    #@-body
    #@-node:18::on_butGenerateKeys
    #@+node:19::tickGenerateKeys
    #@+body
    def tickGenerateKeys(self):
        """
        An evil necessity created by Windows Tk's failure
        to allow threads to access widgets.
        """
    
        #print "tickGenerateKeys: called"
        if not self.threadrunning:
            self.statKeyGen['text'] = "Keys successfully generated"
            self.statKeyGen1['text'] = "Please click 'Next' to continue"
            self.statKeyGen1['font'] = "helvetica 12"
            self.statKeyGen1['fg'] = "#000000"
            self.unfreezePage()
            self.butGenerateKeys['state'] = NORMAL
            return
    
        if self.keyProgress % 8 == 0:
            s = ""
            for i in range(8):
                n = random.randint(0, 0xffff)
                s += "%02x" % n
            self.statKeyGen1['text'] = s
        self.keyProgress += 1
    
        self.butGenerateKeys.after(50, self.tickGenerateKeys)
    
    #@-body
    #@-node:19::tickGenerateKeys
    #@+node:20::threadGenerateKeys
    #@+body
    def threadGenerateKeys(self):
    
        time.sleep(2)
        print "threadGenerateKeys: generating a %d-bit key" % self.valKeySize
        self.valKey = SSLCrypto.key(self.valKeySize, myCallback=self.callbackGenerateKeys)
        #self.valKey = SSLCrypto.key(self.valKeySize, myCallback=None)
        print "threadGenerateKeys: done"
    
        self.threadrunning = False
    
    #@-body
    #@-node:20::threadGenerateKeys
    #@+node:21::callbackGenerateKeys()
    #@+body
    def callbackGenerateKeys(self, level, num):
    
        sys.stdout.write("")
        sys.stdout.flush()
        return
    
        # welcome to a totally gratuitous special effects wank! :)
        if self.keyProgress % 8 == 0:
            s = ""
            for i in range(8):
                n = random.randint(0, 0xffff)
                s += "%02x" % n
            #self.widthrd.after(10,None, s)
            #self.statKeyGen1['text'] = s
        self.keyProgress += 1
    
    #@-body
    #@-node:21::callbackGenerateKeys()
    #@+node:22::on_radKeySize
    #@+body
    def on_radKeySize(self, item):
        self.valKeySize = int(item.split(" ")[0])
        #print"keystrength=%d" % self.valKeySize
    
    #@-body
    #@-node:22::on_radKeySize
    #@+node:23::on_radIncomingConn
    #@+body
    def on_radIncomingConn(self, item):
        self.valIncomingConn = self.connOpts.index(item)
        #print"connopt=%d" % self.valIncomingConn
    
    #@-body
    #@-node:23::on_radIncomingConn
    #@+node:24::on_butAudioOutStart
    #@+body
    def on_butAudioOutStart(self):
    
        #print"start audio out test"
    
        self.freezePage()
        self.butAudioOutStart['state'] = DISABLED
        self.butAudioOutStop['state'] = NORMAL
        self.butAudioInStart['state'] = DISABLED
        self.statAudioTestStatus['text'] = "Output Test running - please adjust\n" \
                                          +"your volume and/ormixer settings"
    
        thread.start_new_thread(self.threadAudioOutTest, ())
    
    #@-body
    #@-node:24::on_butAudioOutStart
    #@+node:25::on_butAudioOutStop
    #@+body
    def on_butAudioOutStop(self):
    
        #print"stop audio out test"
        self.audioTestRunning = False
        self.unfreezePage()
        self.butAudioOutStart['state'] = NORMAL
        self.butAudioOutStop['state'] = DISABLED
        self.butAudioInStart['state'] = NORMAL
        self.statAudioTestStatus['text'] = ""
    
    #@-body
    #@-node:25::on_butAudioOutStop
    #@+node:26::threadAudioOutTest()
    #@+body
    def threadAudioOutTest(self):
    
        self.audioTestRunning = True
        while self.audioTestRunning and psst.running:
            #print"audioOutTestThread"
            psst.playsound("sounds/sample.wav")
            time.sleep(3)
        #print"audioOutTestThread: exiting"
    
    
    #@-body
    #@-node:26::threadAudioOutTest()
    #@+node:27::on_butAudioInStart
    #@+body
    def on_butAudioInStart(self):
        #print"start audio in test"
    
        self.freezePage()
        self.butAudioOutStart['state'] = DISABLED
        self.butAudioInStart['state'] = DISABLED
        self.butAudioInStop['state'] = NORMAL
    
        self.statAudioTestStatus['text'] = "Output Test running - please adjust\n" \
                                          +"your volume and/ormixer settings"
    
        thread.start_new_thread(self.threadAudioInTest, ())
    
    #@-body
    #@-node:27::on_butAudioInStart
    #@+node:28::on_butAudioInStop
    #@+body
    def on_butAudioInStop(self):
        #print"stop audio in test"
        self.audioTestRunning = False
        self.unfreezePage()
        self.butAudioOutStart['state'] = NORMAL
        self.butAudioInStart['state'] = NORMAL
        self.butAudioInStop['state'] = DISABLED
        self.statAudioTestStatus['text'] = ""
    
    #@-body
    #@-node:28::on_butAudioInStop
    #@+node:29::threadAudioInTest()
    #@+body
    def threadAudioInTest(self):
    
        self.audioTestRunning = True
        while self.audioTestRunning and psst.running:
            #print"audioInTestThread"
            time.sleep(2)
            raw = psst.audioObj.readCompressed()
            psst.audioObj.writeCompressed(raw)
            time.sleep(2)
            psst.audioObj.readCompressed()
        #print"audioInTestThread: exiting"
    
    
    #@-body
    #@-node:29::threadAudioInTest()
    #@+node:30::show
    #@+body
    def show(self):
        self.book.selectpage('Start')
        result = self.dlg.activate(geometry='centerscreenalways')
        #print"wizSetup.show: result =", result
        if self.values:
            self.putToConfig(self.values)
            return True
        else:
            return False
    
    #@-body
    #@-node:30::show
    #@+node:31::freezePage
    #@+body
    def freezePage(self):
        """
        Disables the pagelist, prev and next buttons
        """
        
        try:
            self.lstPages.component('listbox')['state'] = DISABLED
        except:
            #print"MISSING 'STATE' var in listbox"
            pass
        self.butPrev['state'] = DISABLED
        self.butNext['state'] = DISABLED
    
    #@-body
    #@-node:31::freezePage
    #@+node:32::unfreezePage
    #@+body
    def unfreezePage(self):
        """
        Re-enables the pagelist, prev and next buttons
        """
        try:
            self.lstPages.component('listbox')['state'] = NORMAL
        except:
            #print"MISSING 'STATE' var in listbox"
            pass
        self.butPrev['state'] = NORMAL
        self.butNext['state'] = NORMAL
    
    #@-body
    #@-node:32::unfreezePage
    #@-others


#@-body
#@-node:1::class wizSetup
#@-node:5::Wizard
#@+node:6::Theme
#@+node:1::class Theme
#@+body
class Theme:
    """
    Loads theme settings, which will be used in construction
    of all gui windows and widgets
    """

    #@+others
    #@+node:1::__init__
    #@+body
    def __init__(self, themename="default"):
    
        self.setDefaultTheme()
    
        #print"themes list:"
        #printTheme.getThemesList()
    
        if themename == "default":
            return # got theme data already
    
        themedir = Theme.getThemesDir()
        
        themefile = os.path.join(themedir, themename+".theme")
        print "Theme file: '%s'" % themefile
    
        try:
            fd = file(themefile)
        except:
            print "Can't open theme file '%s', falling back on defaults" % themefile
            return
    
        # read in settings
        badattribs = ['__doc__', '__init__', '__module__', 'setDefaultTheme']
    
        lines = fd.readlines()
        fd.close()
        i = 0
        ok = True
        settings = {}
        for line in lines:
            i = i + 1
            line = line.strip()
            
            # skip empty lines and comments
            if line == '' or line[0] == '#':
                continue
    
            # theme file entries are in form 'name = "value"'
            bits = line.split("=", 1)
            if len(bits) != 2:
                print "%s.theme:%d:syntax error" % (themename, i)
                ok = False
                return
    
            # validate the record
            name, value = bits
            name = name.strip()
            value = value.strip()
            if name == '' or value == '' or value[0] != '"' or value[-1] != '"':
                print "%s.theme:%d:syntax error" % (themename, i)
                ok = False
                return
    
            # make sure theme file is not trying to set class attribs
            if value in badattribs:
                print "%s.theme:%d:bad attribute '%s' in theme file!!!" % (
                    themename, i, value)
    
            # remove quotes from value
            value = value[1:-1]
            if value == '':
                print "%s.theme:%d:syntax error" % (themename, i)
                ok = False
                return
                
            settings[name] = value
    
        #print settings
    
        if sys.platform != 'win32':
            self.biggerForLinux(settings)
    
        # if we get here, all is good
        #print settings
        for name in settings:
            #print "name=%s value=%s" % (name, settings[name])
            setattr(self, name, settings[name])
    
        # all done
        print "theme %s loaded" % themename
    
    
    
    #@-body
    #@-node:1::__init__
    #@+node:2::setDefaultTheme
    #@+body
    def setDefaultTheme(self):
        defaults = {
            'tkActiveBgColor': "grey",
            'tkActiveFgColor': "black",
            'tkFgColor': "black",
            'tkSelColor': "#D0D0D0",
            'tkHighlightBgColor': "green",
            'tkHighlightColor': "violet",
            'tkSelBgColor': "pink",
            'tkSelFgColor': "white",
            'tkBgColor': "yellow",
            'tkDisabledFgColor': "white",
            'tkInsBgColor': "yellow",
            'tkTroughColor': "green",
            'winBgColor': "#d0d0d0",
            'winFgColor': "yellow",
            'frmBgColor': "#d0d0d0",
            'menuBgColor': "#d0d0d0",
            'menuFgColor': "black",
            'menuFont': "helvetica 8",
            'menuActiveBgColor': "#e0e0e0",
            'menuActiveFgColor': "black",
            'listFont': "helvetica 8",
            'listBgColor': "white",
            'listFgColor': "black",
            'listSelBgColor': "#d0d0d0",
            'listSelFgColor': "black",
            'textBgColor': "white",
            'textFgColor': "black",
            'textSelFgColor': "black",
            'textSelBgColor': "#d0d0d0",
            'textFont': "helvetica 8",
            'butBgColor': "#d0d0d0",
            'butFgColor': "black",
            'butSelColor': "#e0e0e0",
            'butActiveFgColor': "black",
            'butActiveBgColor': "#e0e0e0",
            'butFont': "helvetica 8",
            'butHighlightColor': "#d0d0d0",
            'labBgColor': "#d0d0d0",
            'labFgColor': "black",
            'labFont': "helvetica 8",
            'scrlBgColor': "#d0d0d0",
            'scrlBgActiveColor': "black",
            'scrlFgColor': "#d0d0d0",
            'scrlFgActiveColor': "black",
            'entryFont': "helvetica 8",
            'entryBgColor': "white",
            'entryFgColor': "black",
            'entryDisabledBgColor': "#d0d0d0",
            'entryDisabledFgColor': "#000000",
            'entrySelColor': "#d0d0d0",
            'cmbFont': "helvetica 8",
            'cmbBgColor': "#d0d0d0",
            'cmbFgColor': "black",
            'cmbDisabledBgColor': "#d0d0d0",
            'cmbDisabledFgColor': "#808080",
            'cmbSelBgColor': "#d0d0d0",
            'cmbSelFgColor': "black",
            'chkBgColor': "#d0d0d0",
            'chkFgColor': "black",
            'chkFont': "helvetica 8",
            'chkActiveBgColor': "#e0e0e0",
            'chkActiveFgColor': "black",
            'chkSelColor': "#d0d0d0",
            'radBgColor': "#d0d0d0",
            'radFgColor': "black",
            'radFont': "helvetica 8",
            'radSelColor': "#d0d0d0",
            'radActiveBgColor': "#FFCC00",
            'radActiveFgColor': "black",
            'chatMyTypingColor': "black",
            'chatPeerTypingColor': "#d0d0d0",
            'chatErrorColor': "red",
            'chatMsgColor': "#C0C000",
            'chatOKColor': "#00C000",
            'chatVoxLevelBgColor': "#d0d0d0",
            'chatVoxSendFgColor': "black",
            'chatVoxSendBgColor': "#808080",
            'cntBgColor': "#d0d0d0",
            'cntFgColor': "black",
                   }
    
        if sys.platform != 'win32':
            self.biggerForLinux(defaults)
    
        for name in defaults:
            setattr(self, name, defaults[name])
    
    #@-body
    #@-node:2::setDefaultTheme
    #@+node:3::getThemesList
    #@+body
    def getThemesList():
        themedir = Theme.getThemesDir()
    
        files = os.listdir(themedir)
    
        themes = []
        for f in files:
            if f[-6:] == '.theme' and f[:-6] != '':
                themes.append(f[0:-6])
        return themes
    
    getThemesList = staticmethod(getThemesList)
    
    #@-body
    #@-node:3::getThemesList
    #@+node:4::getThemesDir
    #@+body
    def getThemesDir():
        # try to open and read in chosen theme
        if sys.platform == 'win32':
            themedir = os.path.join(os.getcwd(), "themes")
        else:
            themedir = os.path.join(
                os.path.dirname(os.path.realpath(psst.__file__)), "themes")
        #print "Theme dir: '%s'" % themedir
        return themedir
    
    getThemesDir = staticmethod(getThemesDir)
    
    
    #@-body
    #@-node:4::getThemesDir
    #@+node:5::biggerForLinux
    #@+body
    def biggerForLinux(self, themedata):
        # a bad kludge to scale up the size of non-windows fonts
        for name in themedata.keys():
            value = themedata[name]
    
            try:
                isFont = name.lower().index('font')
            except:
                isFont = False
    
            if not isFont:
                continue
    
            #print "name='%s', value='%s'" % (name, value)
            valueOld = value.split(" ")
            valueNew = []
            for v in valueOld:
                try:
                    n = int(v)
                    valueNew.append("%d" % (n * 4/3))
                except:
                    valueNew.append(v)
            themedata[name] = " ".join(valueNew)
    
    #@-body
    #@-node:5::biggerForLinux
    #@-others


#@-body
#@-node:1::class Theme
#@-node:6::Theme
#@+node:7::Functions
#@+node:1::htmlOpen
#@+body
def htmlOpen(url):
    thread.start_new_thread(webbrowser.open, (url, 0, 1))

#@-body
#@-node:1::htmlOpen
#@-node:7::Functions
#@-node:4::GUI
#@+node:5::Non-GUI
#@+node:1::Classes
#@+node:1::class ConfigFactory
#@+body
class ConfigFactory:

    #@+others
    #@+node:1::__init__()
    #@+body
    def __init__(self, passphrase='', conffile=None):
        global config
    
        #print"ConfigFactory.__init__: config file =", conffile
    
        if conffile == None:
            conffile = "psstConfig.dat"
        self.conffile = conffile
        self.passphrase = passphrase
    
        # generate key object for passphrase config file en/decryption
        self.passKey = SSLCrypto.key(256)
        
        #print"ConfigFactory.__init__: config file =", conffile
    
        #trace()
    
        try:
            # open existing config
            #print "psstConfig.py: __init__: cwd = '%s'" % os.getcwd()
            fd = open(self._conffile(), "rb")
        except:
            # create a new config file
            self.reset()
            return
    
        # read config into a new config object
        raw = fd.read()
        fd.close()
        gotit = False
    
        prmt = "Please enter your personal passphrase"
        try:
            # try to read it unencrypted
            newconf = pickle.loads(raw)
        except:
            #print "can't unpickle config - assuming it's encrypted"
            i = 0
            while i < 3:
                dec = raw
                newconf = None
                result = getpassphrase('PSST Security', 
                                       prmt)
    
                #trace()
    
                if result == None:
                    sys.exit(0)
                else:
                    self.passphrase = result
                try:
                    #print"trying with passphrase '%s'" % self.passphrase
                    self.passKey.setSessKey(self.passphrase, '12345678')
                    dec = self.passKey.decStringSess(dec)
                    newconf = pickle.loads(dec)
                except:
                    i += 1
                    prmt = "Wrong passphrase. Please try again"
                if newconf == None:
                    # prompt for a passphrase
                    continue
                else:
                    break  # successfully decrypted config
    
        #print "ConfigFactory: loaded confdict=", newconf
    
        if newconf == None:
            # failed to access config
            myMessageBox(None,
                         "PSST Security",
                         "Retry limit exceeded\n"
                         +"Failed to enter correct passphrase\n"
                         "PSST will now terminate",
                         'error',
                         ("OK",))
            sys.exit(1)
    
        for fld in newconf.keys():
            if fld not in ['__doc__', '__init__', '__module__', '__del__',
                           '_confdir', '_conffile', 'save', 'reset']:
    
                #print fld
                fldref = getattr(self, fld, None)
                #if type(fldref) is types.MethodType or fldref == None:
                #    print "psstConfig.__init__: ignoring attrib %s" % fld
                #    continue
    
                if fld == 'myKey':
                    # create new key instance using my private key
                    val = SSLCrypto.key(newconf['myKey'])
                elif fld == 'peers':
                    # Create dict of peer pub key instances
                    val = {}
                    for k in newconf['peers'].keys():
                        val[k] = newconf['peers'][k]
                        val[k]['key'] = SSLCrypto.key(newconf['peers'][k]['key'])
                else:
                    val = newconf[fld]
                #print "loading: %s = %s" % (fld, val)
                setattr(self, fld, val)
    
        # backward-compatibility hack to provide list of prior peer IPs
        if getattr(self, 'prevHosts', None) == None:
            self.prevHosts = []
        
        #print "psstConfig.__init__: final loaded dir:"
        #print dir(self)
    
    #@-body
    #@-node:1::__init__()
    #@+node:2::save()
    #@+body
    def save(self):
        """
        save config to file, encrypting if passphrase is non-empty
        """
    
        # build a dict with all config parms
        confdict = {}
        #print "current config attribs:"
        #print dir(self)
    
        #trace()
    
        for fld in dir(self):
            if fld not in ['__doc__', '__init__', '__module__', '__del__',
                           '_confdir', 'conffile', 'save', 'reset'
                           'addPeer', 'removePeer',
                           'setDefaults', 'passKey']:
    
                fldref = getattr(self, fld)
                
                if type(fldref) is types.MethodType:
                    continue
    
                if fld == 'myKey':
                    # export my own private key
                    confdict['myKey'] = self.myKey.exportKeyPrivate()
                elif fld == 'peers':
                    # export all public keys of peers
                    peersDict = {}
                    for k in self.peers.keys():
                        #print"config.save: saving peer key for '%s'" % k
                        peersDict[k] = {}
                        for k1 in self.peers[k].keys():
                            peersDict[k][k1] = self.peers[k][k1]
                        peersDict[k]['key'] = self.peers[k]['key'].exportKey()
                    confdict['peers'] = peersDict
                else:
                    # everything else can just be copied
                    confdict[fld] = getattr(self, fld)
    
        #for fld in confdict.keys():
        #    print "config.save: testing pickle of fld %s" % fld
        #    pickle.dumps(confdict[fld])
    
        # create a pickle - encrypt if needed
        if self.passphrase == '':
            raw = pickle.dumps(confdict, True)
        else:
            raw = pickle.dumps(confdict, False)
            #print "encrypting config with passphrase '%s'" % self.passphrase
            self.passKey.setSessKey(self.passphrase, '12345678')
            raw = self.passKey.encStringSess(raw)
        fd = open(self._conffile(), "wb")
        fd.write(raw)
        fd.close()
        #print"ConfigFactory.save: config saved"
    
    
    #@-body
    #@-node:2::save()
    #@+node:3::reset()
    #@+body
    def reset(self):
        """
        Set some configuration defaults
        """
        #print "config: setting defaults"
    
        # 'valid' flag
        self.valid = False
    
        self.myNick = 'noNick'
    
        # My own key
        self.myKey = None
    
        # Keys of known and trusted peers - dict with keys as nick, values as key objects
        self.peers = {}
    
        # incoming connection parameters
        self.listenPort = 44154
        self.listenHost = '' # accept connections from anywhere
    
        # key parameters
        self.pubKeyCipher = 'RSA'
        self.pubKeyLen = 3072
        self.sessKeyCipher = 'Blowfish'
        self.sessKeyLen = 128
        self.passphrase = ''
    
        self.connIncoming = 0
        self.allowVoice = 0
        self.allowWebProxy = 0
        self.allowFileSharing = 0
        self.fileShareDir = '/dev/null'
    
        # Behaviour
        self.connPlaySound = 1
        self.connPlaySoundFile = 'sounds/teleph.wav'
        self.keysDir = '.'
    
        # Appearance
        self.fontSize = 12
    
    #@-body
    #@-node:3::reset()
    #@+node:4::addPeer()
    #@+body
    def addPeer(self, nick, **kwds):
        """
        Adds peer to config
    
        Arguments:
         - nick - nick of peer as a string
        Keywords:
         - default poer, permissions etc - see dlgPeer dialog resource
        """
        self.peers[nick] = kwds
    
    #@-body
    #@-node:4::addPeer()
    #@+node:5::removePeer()
    #@+body
    def removePeer(self, nick):
        """
        Deletes a peer from our configuration
        """
        if self.peers.has_key(nick):
            del self.peers[nick]
    
    #@-body
    #@-node:5::removePeer()
    #@+node:6::_conffile()
    #@+body
    def _conffile(self):
        if self.conffile[0] == '/':
            return self.conffile
        else:
            return os.path.join(self._confdir(), self.conffile)
    
    #@-body
    #@-node:6::_conffile()
    #@+node:7::_confdir()
    #@+body
    def _confdir(self):
        """
        Returns the directory in which the config file should reside
    
        On windows, it's the program directory.
        On *nix, it's the user's home directory
        """
        #return os.path.dirname(os.path.abspath(__file__))
        #return os.path.dirname(psst.__file__)
    
        #print "IMPORTANT - (ConfigFactory._confdir(): verify if os.path.ecpanduser works on windows and *nix)"
    
        if sys.platform == 'win32':
            return os.getcwd()
        else:
            #return os.path.dirname(psst.__file__)
            return os.path.expanduser('~')
            return os.getenv("HOME")
    
    #@-body
    #@-node:7::_confdir()
    #@-others


#@-body
#@-node:1::class ConfigFactory
#@+node:2::class connection
#@+body
class connection:
    """
    An abstract connection object.

    Initially, these can only be created with TCP sockets,
    but may extend later to other transports
    """

    #@+others
    #@+node:1::__init__()
    #@+body
    def __init__(self, queue, key, peer, type, transport):
        """
        Connection constructor
    
        Arguments:
         - queue - queue used to relay incoming data to client window
         - key - our own SSLCrypto key object
         - peer - name of peer we're talking to, or None
         - type - string - type of connection - allowable values are:
            - tcp - TCP stream connection
         - transport - object - depends on type. Possibilities include:
            - if type is 'tcp', then 'socket'
        """
    
        # the handshaking states are:
        # 'handshaking' - performing handshaking
        # 'ready' - ok to send
        # 'closed' - session failed, or was closed
        self.state = 'handshaking' # used by rx/handshake thread 'threadRx()'
    
        self.queue = queue # queue for passing received data to client
        self.mykey = key
        if peer == None:
            self.outbound = False # we're receiving the connection
            peer = "UNKNOWN"
        else:
            self.outbound = True # we initiated the connection
            
        self.peer = peer
        self.type = type
        if type == 'tcp':
            self.transport = transport
        self.sendlock = thread.allocate_lock()
    
        # launch receive thread
        thread.start_new_thread(self.threadRx, ())
    
    #@-body
    #@-node:1::__init__()
    #@+node:2::send()
    #@+body
    def send(self, msgtype, buf=''):
        """
        Sends a string buffer to peer
    
        Data is sent as:
         - type char (H)andshaking, (T)ext, (V)oice, (P)ing
         - num length bytes
         - length bytes, LSB first
         - actual data
        """
    
        if self.state == 'closed':
            raise ConnectionClosedError
    
        if msgtype != 'H': # fudgy override to allow handshaking
            while self.state != 'ready':
                #print"connection.send: not ready to send"
                logMsg("Waiting to finish handshake with peer %s" % self.peer)
                time.sleep(3)
                    
        if msgtype == 'P':
            buf = 'P'
        else:
            # build length header
            tmp = bufLen = len(buf)
            lenbytes = ''
            while tmp > 0:
                tmp, mod = divmod(tmp, 256)
                lenbytes += chr(mod)
            if msgtype == 'H':
                typebyte = ''
            else:
                typebyte = msgtype
            buf = typebyte + chr(len(lenbytes)) + lenbytes + buf
    
        #trace()
    
        # Get the send lock
        self.sendlock.acquire()
        if self.type == 'tcp':
    
            # encrypt to session key if not handshaking
            if msgtype != 'H':
                #print "connection.send: plaintext=%s" % str(buf)
                buf = self.mykey.encStringSess(buf)
                #print "connection.send: cipher=%s", hexdump(buf)
    
            self.transport.send(buf)
            #print "connection.send: sent %d bytes:" % (bufLen + len(hdr))
            #print hexdump(hdr+buf)
    
        # don't need send lock any more
        self.sendlock.release()
    
    #@-body
    #@-node:2::send()
    #@+node:3::_recv()
    #@+body
    def _recv(self, handshaking=False, blocking=True):
        """
        Receives one chunk from connection, as sent from other end
    
        Processes the length header, and guarantees the receipt of all data
    
        Users of this class should not call this method directly - but instead
        monitor their receive queue.
    
        This method should only be called by the threadRx() thread
        """
    
        if self.type == 'tcp':
    
            # grab type byte, if any
            if not handshaking:
                msgtype = self._recvchunk(1, handshaking, blocking)
                if msgtype == 'P':
                    return ('P', None)
    
            # grab length header
            LenLen = ord(self._recvchunk(1, handshaking, blocking))
            # print "connection._recv: LenLen=%02x" % LenLen
            lenbuf = ''
            for i in range(LenLen):
                lenbuf = self._recvchunk(1, handshaking, blocking) + lenbuf
            Len = 0
            for i in lenbuf:
                Len = Len * 256 + ord(i)
            #print "connection.recv: Len (MSB first)=%s" % hexdump(lenbuf)
    
            # grab actual data
            buf = self._recvchunk(Len, handshaking, blocking)
    
            # return raw if handshaking, otherwise (type, data) tuple
            if handshaking:
                return buf
            else:
                return (msgtype, buf)
    
    
    def _recvchunk(self, size, plaintext=False, blocking=True):
        """
        Guarantees the receipt of an exact number of bytes
        """
    
        if self.type == 'tcp':
            buf = ''
            while size > 0:
                try:
                    #if not plaintext:
                    #    trace()
                    chunk = self.transport.recv(size)
                    #print "*** BACK FROM recv() ***"
                    if not plaintext:
                        chunk = self.peerkey.decStringSess(chunk)
                except socket.error, msg:
                    if msg[0] == 9:
                        chunk = None
                    else:
                        raise
                except:
                    chunk = None
                if chunk == '' or chunk == None:
                    #print"connection._recvchunk: socket closed"
                    self.close()
                    raise ConnectionClosedError
                buf += chunk
                size -= len(chunk)
        return buf
    
    #@-body
    #@-node:3::_recv()
    #@+node:4::close()
    #@+body
    def close(self):
        """
        Terminates this connection
        """
        #print"connection.close"
        if self.type == 'tcp':
            #print"connection.close: closing tcp"
            self.transport.close()
            gWinMain.showPeerNotConnected(self.peer)
            self.state = 'closed'
            try:
                del gConnections[self.peer]
            except:
                pass
    
    #@-body
    #@-node:4::close()
    #@+node:5::threadRx()
    #@+body
    def threadRx(self):
        """
        Thread which listens for incoming data, and passes it
        onto receive queue,
    
        Also, this thread is responsible for the initial handshaking
        to set up the session.
        """
    
        #trace()
    
        # Start initial handshaking
        logMsg("connection.threadRx: starting peer authentication")
    
        # Step 1 - send hash of our public key
        self.putClientQueue({'type':'status',
                             'text':"Sending hashed public key to peer"})
        self.send('H', sha.new(self.mykey.exportKey()).digest())
    
        # Step 2 - receive peer's public key (hashed)
    
        # set socket non-blocking to pick up rejected connections
        self.putClientQueue({'type':'status',
                             'text':"Awaiting peer's public key"})
        self.transport.setblocking(0)
        rejected = 0
        for i in range(90):
            try:
                peerKeyHash = self._recv(True)
                break
            except ConnectionClosedError:
                rejected = True
                break
            except:
                time.sleep(1)
    
        if i >= 89 or rejected:
            # it's all over - bail out
            logMsg("connection.threadRx: remote peer closed connection")
            self.close()
            if rejected:
                self.putClientQueue({'type':'connClose',
                                     'reason':'remote peer declined your connection'})
            else:
                self.putClientQueue({'type':'connClose',
                                     'reason':'Connection timeout'})
            try:
                del gConnections[peer]
            except:
                pass
            return
    
        # reinstate blocking mode
        self.transport.setblocking(1)
        
        logMsg("connection.threadRx: received peer pubkey hash")
        self.putClientQueue({'type':'status',
                             'text':"Verifying peer's public key"})
    
        # Step 3 - compare with known keys
        found = 0
        for peer in psst.config.peers.keys():
            knownPeerPub = psst.config.peers[peer]['key'].exportKey()
            knownPeerHash = sha.new(knownPeerPub).digest()
            if peerKeyHash == knownPeerHash:
                self.peer = peer
                found = 1
                break
    
        if not found:
            logMsg("connection.threadRx: rejecting unknown peer")
            self.queue.put({'type':'close', 'reason':'unknown public key'})
            self.putClientQueue({'type':'connClose',
                                 'reason':"Don't have public key for connecting peer"})
            self.close()
            self.state = 'closed'
            return # sayonara
    
        logMsg("connection.threadRx: peer is known - continuing authentication")
    
        # Step 4 - got valid public key - grab it
        peerPubStr = psst.config.peers[peer]['key'].exportKey()
        self.peerkey = SSLCrypto.key(peerPubStr)
    
        # Step 5 - generate my own sess key and iv
        self.mykey.genSessKey()
    
        # Step 6 - encrypt sess key and IV, send these to peer
        mySess = self.mykey.getSessKey()
        mySessEnc = self.peerkey._encRawPub(mySess)
        self.send('H', mySessEnc)
        myIV = self.mykey.getSessIV()
        myIVEnc = self.peerkey._encRawPub(myIV)
        self.send('H', myIVEnc)
    
        # Step 7 - sign these, encrypt signature, send to peer
        mysig = self.mykey.signString(mySess + myIV, False)
        mysiglen = len(mysig)
    
        # send block count
        nblocks = (mysiglen + 31) / 32
        self.send('H', chr(nblocks))
    
        #break up into blocks
        n = 0
        while n < mysiglen:
            plain = mysig[n:n+32]
            enc = self.peerkey._encRawPub(plain)
            self.send('H', enc)
            n += 32
    
        logMsg("connection.threadRx: awaiting session parameters from peer")
    
        # Step 8 - receive and decrypt peer sesskey and IV
        peerSessEnc = self._recv(True)
        peerSess = self.mykey._decRawPub(peerSessEnc)
        peerIVEnc = self._recv(True)
        peerIV = self.mykey._decRawPub(peerIVEnc)
    
        # Step 9 - receive and reassemble signature of sesskey,IV
        # format is a count byte, which indicates the number of following
        # chunks
    
        logMsg("connection.threadRx: awaiting signature from peer")
    
        byte = self._recv(True)
        peerSigNblocks = ord(byte)
        peerSig = ''
        for i in range(peerSigNblocks):
            encblk = self._recv(True)
            decblk = self.mykey._decRawPub(encblk)
            peerSig += decblk
        
        # Step 10 - validate signature
        if not self.peerkey.verifyString(peerSess+peerIV, peerSig, False):
            logMsg("threadRx: Bad signature from peer")
            self.putClientQueue({'type':'connClose', 'reason':'bad signature'})
            self.close()
            self.state = 'closed'
            logMsg("connection.threadRx: bad peer signature - aborting")
            return # hastalavista baby
    
        logMsg("connection.threadRx: peer signature is valid")
        self.putClientQueue({'type':'status',
                             'text':"Peer's signature is valid"})
    
        # Set up peer key with now-validated peer sessKey and IV
        self.peerkey.setSessKey(peerSess, peerIV)
    
        # Success - ready to run with live data
        self.state = 'ready'
        self.putClientQueue({'type':'connOK'})
        putMainQueue({'type':'connOk', 'peer':peer})
    
        # Launch pinger thread
        thread.start_new_thread(self.threadPing, ())
    
        # Session active loop - receive and decrypt data, pass to queue
        logMsg("AUTHENTICATION SUCCESSFUL\nSECURED CONNECTION NOW OPEN")
        while psst.running:
            try:
                #trace()
                msgtype, buf = self._recv()
            except ConnectionClosedError:
                # it's all over - bail out
                logMsg("connection.threadRx: remote peer closed connection")
                self.close()
                self.putClientQueue({'type':'connClose',
                                     'reason':'remote closed connection'})
                try:
                    del gConnections[peer]
                except:
                    pass
                return
    
            #print "got from peer: [%s] %s" % (msgtype, str(buf))
            if msgtype == 'P':
                # got a ping
                self.lastPingTime = time.time()
                continue
    
            self.putClientQueue({'type':'rxdata',
                                 'rxtype':msgtype,
                                 'data':buf})
    
    
    #@-body
    #@-node:5::threadRx()
    #@+node:6::threadPing()
    #@+body
    def threadPing(self):
        """
        Thread which repeatedly sends ping messages to remote peer.
    
        If a send fails, or it's been too long since receiving
        the last ping, the socket is closed
        """
        self.lastPingTime = time.time()
    
        #print"connection.threadPing: pinger thread started"
    
        try:
            while psst.running:
                self.send('P', '')
                if time.time() - self.lastPingTime > pingTimeout:
                    self.putClientQueue(
                        {'type':'connClose',
                         'reason':'ping timeout'
                         })
                    
                    self.transport.close()
                    return
                time.sleep(5)
        except:
            try:
                self.transport.close()
            except:
                pass
            return
    
    #@-body
    #@-node:6::threadPing()
    #@+node:7::putClientQueue()
    #@+body
    def putClientQueue(self, item):
        #print "putClientQueue: enqueueing: ", item
        self.queue.put(item)
        #wx.wxWakeUpIdle()
        
    
    #@-body
    #@-node:7::putClientQueue()
    #@-others


#@-body
#@-node:2::class connection
#@+node:3::class constants
#@+body
class constants:
    # limit queue size
    qMaxSize = 4096

    # default port number for daemon command channel
    daemonPort = 55191

#@-body
#@-node:3::class constants
#@-node:1::Classes
#@+node:2::Functions
#@+node:1::takeKey()
#@+body
def takeKey(somedict, keyname, default=None):
    """
    Utility function to destructively read a key from a given dict.
    Same as the dict's 'takeKey' method, except that the key (if found)
    sill be deleted from the dictionary.
    """
    if somedict.has_key(keyname):
        val = somedict[keyname]
        del somedict[keyname]
    else:
        val = default
    return val

#@-body
#@-node:1::takeKey()
#@+node:2::putMainQueue()
#@+body
def putMainQueue(something):
    """
    Send a message to the main window
    """
    queueMain.put(something)
    gWinMain.frmMain.after(10, app.on_idle)
    #wx.wxWakeUpIdle()

#@-body
#@-node:2::putMainQueue()
#@+node:3::logMsg()
#@+body
def logMsg(msg):
    putMainQueue({'type':'log', 'text':msg})

#@-body
#@-node:3::logMsg()
#@-node:2::Functions
#@+node:3::Threads
#@+node:1::threadDummy()
#@+body
def threadDummy():
    n = 0
    while psst.running:
        time.sleep(1)
        putMainQueue({'type':'log', 'text':"threadDummy: n = %d" % n})
        n += 1

#@-body
#@-node:1::threadDummy()
#@+node:2::threadListener()
#@+body
def threadListener(config, queuePutFunc):
    """
    Listens for incoming connections, and passes these
    to the main queue
    """
    #print "threadListener: config has: %s" % dir(config)

    sockMain = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    # Try to bind to socket
    port = int(psst.config.listenPort)
    while 1:
        try:
            sockMain.bind((psst.config.listenHost, port))
            sockMain.listen(1)
            break # bound ok
        except:
            print "Can't bind to port %d - retrying in 5 seconds" % port
            time.sleep(5)

    logMsg("threadListener: awaiting peer connections on port %d" % port)

    # main loop - receive incoming connections, vet them and pass 'em on
    while psst.running:
        peerSock, peerAddr = sockMain.accept()

        # FIX THIS!!!
        peer = 'UNKNOWN!!!!'

        logMsg("Incoming peer connection from: %s" % peerAddr[0])
        queuePutFunc({'type':'gotConnect',
                      'host':peerAddr[0],
                      'peer':peer,
                      'sock':peerSock})


#@-body
#@-node:2::threadListener()
#@+node:3::threadConnect()
#@+body
def threadConnect(nick, host, port):
    """
    
    Attempts to place a connection with peer at host:port

    Arguments:
     - nick
     - host
     - port
    """

    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    logMsg("Connecting to %s at %s:%s..." % (nick, host, port))
    try:
        port = int(port)
        sock.connect((host, port))
    except socket.error, msg:
        # physically unable to connect
        putMainQueue({'type':'connRejected',
                      'peer':nick,
                      'host':host,
                      'port':port,
                      'reason':msg
                      })
        return

    putMainQueue({'type':'log',
                  'text':"Waiting for peer's consent..."
                  })

    sock.setblocking(0)
    timeout = 0
    for i in range(90):
        try:
            reply = sock.recv(1)
            break
        except socket.error, msg:
            if msg[0] == 11 or msg[0] == 10035: # yikes - where's the constant??
                time.sleep(1)
                continue # resource unavailable
            else:
                putMainQueue({'type':'connRejected',
                              'peer':nick,
                              'host':host,
                              'port':port,
                              'reason':msg,
                              })
                sock.close()
                return
    sock.setblocking(0)
    if i >= 89:
        putMainQueue({'type':'connRejected',
                      'peer':nick,
                      'host':host,
                      'port':port,
                      'reason':'Timeout waiting for peer to accept',
                      })
        sock.close()
        return

    if reply == '0':
        putMainQueue({'type':'connRejected',
                      'peer':nick,
                      'host':host,
                      'port':port,
                      'reason':"Connection declined",
                      })
        sock.close()
        return
    elif reply == '1':
        # await '1' or '0' from peer
        putMainQueue({'type':'connAccepted',
                      'peer':nick,
                      'host':host,
                      'port':port,
                      'sock':sock,
                      })
    else:
        putMainQueue({'type':'connRejected',
                      'peer':nick,
                      'host':host,
                      'port':port,
                      'reason':"Protocol Error - please upgrade your PSST",
                      })
        sock.close()
        return

#@-body
#@-node:3::threadConnect()
#@-node:3::Threads
#@+node:4::Utility stuff
#@+body

# thnx Mike Fletcher
#screenWidth =  wx.wxSystemSettings_GetSystemMetric(wx.wxSYS_SCREEN_X)
#screenHeight = wx.wxSystemSettings_GetSystemMetric(wx.wxSYS_SCREEN_Y)
#if wx.wxPlatform != '__WXGTK__':
#    _startx, _starty, screenWidth, screenHeight = wxGetClientDisplayRect()
#else:
#    # handle dual monitors on Linux
#    if screenWidth / screenHeight >= 2:
#        screenWidth = screenWidth / 2
#
#    #screenWidth = int(screenWidth - verticalTaskbarWidth)
#    #screenHeight = int(screenHeight - horizontalTaskbarHeight)

progdir = os.path.dirname(os.path.abspath(psst.__file__))

#@-body
#@+node:1::nullObject
#@+body
class nullObject:
    """
    Class used as a container for putting stuff into
    """
    pass

#@-body
#@-node:1::nullObject
#@+node:2::class unimethod
#@+body
class unimethod(object):
    # universal method: binds to either a class or an instance
    def __init__(self, func):
        self.func = func

    def __get__(self, inst, type=None):
        if inst is None:
            # bind to the class
            return _BoundMethod(self.func, type)
        else:
            # bind to the instance
            return _BoundMethod(self.func, inst)

class _BoundMethod:
    # Helper class.
    def __init__(self, func, first):
        self.func = func
        self.first = first
    
    def __call__(self, *args, **argdict):
        return self.func(self.first, *args, **argdict)

#@-body
#@-node:2::class unimethod
#@+node:3::playsoundNull()
#@+body
def playsoundNull(*args):
    """
    Null function that does nothing

    Gets assigned to psst.playsound when soundcard is not up.
    """
    pass

#@-body
#@-node:3::playsoundNull()
#@-node:4::Utility stuff
#@-node:5::Non-GUI
#@+node:6::MAINLINE
#@+body

def main():
    global app
    #trace()
    root = Tk()

    #root.wm_resizable(1, 0)
    try:
        app = winMain(root)
        root.mainloop()
    except KeyboardInterrupt:
        sys.exit(0)
    except:
        raise
    
if __name__ == '__main__':
    main()

#@-body
#@-node:6::MAINLINE
#@-others


"""
PSST II - reimplemented to use Tkinter
"""


#@-body
#@-node:0::@file tkpsst.py
#@-leo
